package lumag.rtf;


public class CodePageTables {
	// FIXME: provide support for these codepages:
	// 708, 709, 710, 711, 819, 860, 863, 864, 865, 932, 936, 949, 950, 1361

	private static char[] cp437 = {
		/* 0x80 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0x81 */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0x82 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0x83 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0x84 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0x85 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0x86 */ 0x00E5, /* LATIN SMALL LETTER A WITH RING ABOVE */ 
		/* 0x87 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0x88 */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0x89 */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0x8A */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0x8B */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0x8C */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0x8D */ 0x00EC, /* LATIN SMALL LETTER I WITH GRAVE */ 
		/* 0x8E */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0x8F */ 0x00C5, /* LATIN CAPITAL LETTER A WITH RING ABOVE */ 
		/* 0x90 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0x91 */ 0x00E6, /* LATIN SMALL LETTER AE */ 
		/* 0x92 */ 0x00C6, /* LATIN CAPITAL LETTER AE */ 
		/* 0x93 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0x94 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0x95 */ 0x00F2, /* LATIN SMALL LETTER O WITH GRAVE */ 
		/* 0x96 */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0x97 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0x98 */ 0x00FF, /* LATIN SMALL LETTER Y WITH DIAERESIS */ 
		/* 0x99 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0x9A */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0x9B */ 0x00A2, /* CENT SIGN */ 
		/* 0x9C */ 0x00A3, /* POUND SIGN */ 
		/* 0x9D */ 0x00A5, /* YEN SIGN */ 
		/* 0x9E */ 0x20A7, /* PESETA SIGN */ 
		/* 0x9F */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0xA0 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xA1 */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xA2 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xA3 */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xA4 */ 0x00F1, /* LATIN SMALL LETTER N WITH TILDE */ 
		/* 0xA5 */ 0x00D1, /* LATIN CAPITAL LETTER N WITH TILDE */ 
		/* 0xA6 */ 0x00AA, /* FEMININE ORDINAL INDICATOR */ 
		/* 0xA7 */ 0x00BA, /* MASCULINE ORDINAL INDICATOR */ 
		/* 0xA8 */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xA9 */ 0x2310, /* REVERSED NOT SIGN */ 
		/* 0xAA */ 0x00AC, /* NOT SIGN */ 
		/* 0xAB */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xAC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xAD */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xAE */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAF */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xB0 */ 0x2591, /* LIGHT SHADE */ 
		/* 0xB1 */ 0x2592, /* MEDIUM SHADE */ 
		/* 0xB2 */ 0x2593, /* DARK SHADE */ 
		/* 0xB3 */ 0x2502, /* BOX DRAWINGS LIGHT VERTICAL */ 
		/* 0xB4 */ 0x2524, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */ 
		/* 0xB5 */ 0x2561, /* BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE */ 
		/* 0xB6 */ 0x2562, /* BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE */ 
		/* 0xB7 */ 0x2556, /* BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE */ 
		/* 0xB8 */ 0x2555, /* BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE */ 
		/* 0xB9 */ 0x2563, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */ 
		/* 0xBA */ 0x2551, /* BOX DRAWINGS DOUBLE VERTICAL */ 
		/* 0xBB */ 0x2557, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */ 
		/* 0xBC */ 0x255D, /* BOX DRAWINGS DOUBLE UP AND LEFT */ 
		/* 0xBD */ 0x255C, /* BOX DRAWINGS UP DOUBLE AND LEFT SINGLE */ 
		/* 0xBE */ 0x255B, /* BOX DRAWINGS UP SINGLE AND LEFT DOUBLE */ 
		/* 0xBF */ 0x2510, /* BOX DRAWINGS LIGHT DOWN AND LEFT */ 
		/* 0xC0 */ 0x2514, /* BOX DRAWINGS LIGHT UP AND RIGHT */ 
		/* 0xC1 */ 0x2534, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */ 
		/* 0xC2 */ 0x252C, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */ 
		/* 0xC3 */ 0x251C, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */ 
		/* 0xC4 */ 0x2500, /* BOX DRAWINGS LIGHT HORIZONTAL */ 
		/* 0xC5 */ 0x253C, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */ 
		/* 0xC6 */ 0x255E, /* BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE */ 
		/* 0xC7 */ 0x255F, /* BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE */ 
		/* 0xC8 */ 0x255A, /* BOX DRAWINGS DOUBLE UP AND RIGHT */ 
		/* 0xC9 */ 0x2554, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */ 
		/* 0xCA */ 0x2569, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */ 
		/* 0xCB */ 0x2566, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */ 
		/* 0xCC */ 0x2560, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */ 
		/* 0xCD */ 0x2550, /* BOX DRAWINGS DOUBLE HORIZONTAL */ 
		/* 0xCE */ 0x256C, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */ 
		/* 0xCF */ 0x2567, /* BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD0 */ 0x2568, /* BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD1 */ 0x2564, /* BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD2 */ 0x2565, /* BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD3 */ 0x2559, /* BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE */ 
		/* 0xD4 */ 0x2558, /* BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE */ 
		/* 0xD5 */ 0x2552, /* BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE */ 
		/* 0xD6 */ 0x2553, /* BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE */ 
		/* 0xD7 */ 0x256B, /* BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD8 */ 0x256A, /* BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD9 */ 0x2518, /* BOX DRAWINGS LIGHT UP AND LEFT */ 
		/* 0xDA */ 0x250C, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */ 
		/* 0xDB */ 0x2588, /* FULL BLOCK */ 
		/* 0xDC */ 0x2584, /* LOWER HALF BLOCK */ 
		/* 0xDD */ 0x258C, /* LEFT HALF BLOCK */ 
		/* 0xDE */ 0x2590, /* RIGHT HALF BLOCK */ 
		/* 0xDF */ 0x2580, /* UPPER HALF BLOCK */ 
		/* 0xE0 */ 0x03B1, /* GREEK SMALL LETTER ALPHA */ 
		/* 0xE1 */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE2 */ 0x0393, /* GREEK CAPITAL LETTER GAMMA */ 
		/* 0xE3 */ 0x03C0, /* GREEK SMALL LETTER PI */ 
		/* 0xE4 */ 0x03A3, /* GREEK CAPITAL LETTER SIGMA */ 
		/* 0xE5 */ 0x03C3, /* GREEK SMALL LETTER SIGMA */ 
		/* 0xE6 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xE7 */ 0x03C4, /* GREEK SMALL LETTER TAU */ 
		/* 0xE8 */ 0x03A6, /* GREEK CAPITAL LETTER PHI */ 
		/* 0xE9 */ 0x0398, /* GREEK CAPITAL LETTER THETA */ 
		/* 0xEA */ 0x03A9, /* GREEK CAPITAL LETTER OMEGA */ 
		/* 0xEB */ 0x03B4, /* GREEK SMALL LETTER DELTA */ 
		/* 0xEC */ 0x221E, /* INFINITY */ 
		/* 0xED */ 0x03C6, /* GREEK SMALL LETTER PHI */ 
		/* 0xEE */ 0x03B5, /* GREEK SMALL LETTER EPSILON */ 
		/* 0xEF */ 0x2229, /* INTERSECTION */ 
		/* 0xF0 */ 0x2261, /* IDENTICAL TO */ 
		/* 0xF1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xF2 */ 0x2265, /* GREATER-THAN OR EQUAL TO */ 
		/* 0xF3 */ 0x2264, /* LESS-THAN OR EQUAL TO */ 
		/* 0xF4 */ 0x2320, /* TOP HALF INTEGRAL */ 
		/* 0xF5 */ 0x2321, /* BOTTOM HALF INTEGRAL */ 
		/* 0xF6 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF7 */ 0x2248, /* ALMOST EQUAL TO */ 
		/* 0xF8 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xF9 */ 0x2219, /* BULLET OPERATOR */ 
		/* 0xFA */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xFB */ 0x221A, /* SQUARE ROOT */ 
		/* 0xFC */ 0x207F, /* SUPERSCRIPT LATIN SMALL LETTER N */ 
		/* 0xFD */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xFE */ 0x25A0, /* BLACK SQUARE */ 
		/* 0xFF */ 0x00A0, /* NO-BREAK SPACE */ 
	};

	private static char[] cp720 = {
		/* 0x80 */			0x20,
		/* 0x81 */			0x20,
		/* 0x82 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0x83 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0x84 */			0x20,
		/* 0x85 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0x86 */			0x20,
		/* 0x87 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0x88 */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0x89 */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0x8A */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0x8B */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0x8C */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0x8D */			0x20,
		/* 0x8E */			0x20,
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x0651, /* ARABIC SHADDA */ 
		/* 0x92 */ 0x0652, /* ARABIC SUKUN */ 
		/* 0x93 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0x94 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0x95 */ 0x0640, /* ARABIC TATWEEL */ 
		/* 0x96 */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0x97 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0x98 */ 0x0621, /* ARABIC LETTER HAMZA */ 
		/* 0x99 */ 0x0622, /* ARABIC LETTER ALEF WITH MADDA ABOVE */ 
		/* 0x9A */ 0x0623, /* ARABIC LETTER ALEF WITH HAMZA ABOVE */ 
		/* 0x9B */ 0x0624, /* ARABIC LETTER WAW WITH HAMZA ABOVE */ 
		/* 0x9C */ 0x00A3, /* POUND SIGN */ 
		/* 0x9D */ 0x0625, /* ARABIC LETTER ALEF WITH HAMZA BELOW */ 
		/* 0x9E */ 0x0626, /* ARABIC LETTER YEH WITH HAMZA ABOVE */ 
		/* 0x9F */ 0x0627, /* ARABIC LETTER ALEF */ 
		/* 0xA0 */ 0x0628, /* ARABIC LETTER BEH */ 
		/* 0xA1 */ 0x0629, /* ARABIC LETTER TEH MARBUTA */ 
		/* 0xA2 */ 0x062A, /* ARABIC LETTER TEH */ 
		/* 0xA3 */ 0x062B, /* ARABIC LETTER THEH */ 
		/* 0xA4 */ 0x062C, /* ARABIC LETTER JEEM */ 
		/* 0xA5 */ 0x062D, /* ARABIC LETTER HAH */ 
		/* 0xA6 */ 0x062E, /* ARABIC LETTER KHAH */ 
		/* 0xA7 */ 0x062F, /* ARABIC LETTER DAL */ 
		/* 0xA8 */ 0x0630, /* ARABIC LETTER THAL */ 
		/* 0xA9 */ 0x0631, /* ARABIC LETTER REH */ 
		/* 0xAA */ 0x0632, /* ARABIC LETTER ZAIN */ 
		/* 0xAB */ 0x0633, /* ARABIC LETTER SEEN */ 
		/* 0xAC */ 0x0634, /* ARABIC LETTER SHEEN */ 
		/* 0xAD */ 0x0635, /* ARABIC LETTER SAD */ 
		/* 0xAE */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAF */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xB0 */ 0x2591, /* LIGHT SHADE */ 
		/* 0xB1 */ 0x2592, /* MEDIUM SHADE */ 
		/* 0xB2 */ 0x2593, /* DARK SHADE */ 
		/* 0xB3 */ 0x2502, /* BOX DRAWINGS LIGHT VERTICAL */ 
		/* 0xB4 */ 0x2524, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */ 
		/* 0xB5 */ 0x2561, /* BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE */ 
		/* 0xB6 */ 0x2562, /* BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE */ 
		/* 0xB7 */ 0x2556, /* BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE */ 
		/* 0xB8 */ 0x2555, /* BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE */ 
		/* 0xB9 */ 0x2563, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */ 
		/* 0xBA */ 0x2551, /* BOX DRAWINGS DOUBLE VERTICAL */ 
		/* 0xBB */ 0x2557, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */ 
		/* 0xBC */ 0x255D, /* BOX DRAWINGS DOUBLE UP AND LEFT */ 
		/* 0xBD */ 0x255C, /* BOX DRAWINGS UP DOUBLE AND LEFT SINGLE */ 
		/* 0xBE */ 0x255B, /* BOX DRAWINGS UP SINGLE AND LEFT DOUBLE */ 
		/* 0xBF */ 0x2510, /* BOX DRAWINGS LIGHT DOWN AND LEFT */ 
		/* 0xC0 */ 0x2514, /* BOX DRAWINGS LIGHT UP AND RIGHT */ 
		/* 0xC1 */ 0x2534, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */ 
		/* 0xC2 */ 0x252C, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */ 
		/* 0xC3 */ 0x251C, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */ 
		/* 0xC4 */ 0x2500, /* BOX DRAWINGS LIGHT HORIZONTAL */ 
		/* 0xC5 */ 0x253C, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */ 
		/* 0xC6 */ 0x255E, /* BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE */ 
		/* 0xC7 */ 0x255F, /* BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE */ 
		/* 0xC8 */ 0x255A, /* BOX DRAWINGS DOUBLE UP AND RIGHT */ 
		/* 0xC9 */ 0x2554, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */ 
		/* 0xCA */ 0x2569, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */ 
		/* 0xCB */ 0x2566, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */ 
		/* 0xCC */ 0x2560, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */ 
		/* 0xCD */ 0x2550, /* BOX DRAWINGS DOUBLE HORIZONTAL */ 
		/* 0xCE */ 0x256C, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */ 
		/* 0xCF */ 0x2567, /* BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD0 */ 0x2568, /* BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD1 */ 0x2564, /* BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD2 */ 0x2565, /* BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD3 */ 0x2559, /* BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE */ 
		/* 0xD4 */ 0x2558, /* BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE */ 
		/* 0xD5 */ 0x2552, /* BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE */ 
		/* 0xD6 */ 0x2553, /* BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE */ 
		/* 0xD7 */ 0x256B, /* BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD8 */ 0x256A, /* BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD9 */ 0x2518, /* BOX DRAWINGS LIGHT UP AND LEFT */ 
		/* 0xDA */ 0x250C, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */ 
		/* 0xDB */ 0x2588, /* FULL BLOCK */ 
		/* 0xDC */ 0x2584, /* LOWER HALF BLOCK */ 
		/* 0xDD */ 0x258C, /* LEFT HALF BLOCK */ 
		/* 0xDE */ 0x2590, /* RIGHT HALF BLOCK */ 
		/* 0xDF */ 0x2580, /* UPPER HALF BLOCK */ 
		/* 0xE0 */ 0x0636, /* ARABIC LETTER DAD */ 
		/* 0xE1 */ 0x0637, /* ARABIC LETTER TAH */ 
		/* 0xE2 */ 0x0638, /* ARABIC LETTER ZAH */ 
		/* 0xE3 */ 0x0639, /* ARABIC LETTER AIN */ 
		/* 0xE4 */ 0x063A, /* ARABIC LETTER GHAIN */ 
		/* 0xE5 */ 0x0641, /* ARABIC LETTER FEH */ 
		/* 0xE6 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xE7 */ 0x0642, /* ARABIC LETTER QAF */ 
		/* 0xE8 */ 0x0643, /* ARABIC LETTER KAF */ 
		/* 0xE9 */ 0x0644, /* ARABIC LETTER LAM */ 
		/* 0xEA */ 0x0645, /* ARABIC LETTER MEEM */ 
		/* 0xEB */ 0x0646, /* ARABIC LETTER NOON */ 
		/* 0xEC */ 0x0647, /* ARABIC LETTER HEH */ 
		/* 0xED */ 0x0648, /* ARABIC LETTER WAW */ 
		/* 0xEE */ 0x0649, /* ARABIC LETTER ALEF MAKSURA */ 
		/* 0xEF */ 0x064A, /* ARABIC LETTER YEH */ 
		/* 0xF0 */ 0x2261, /* IDENTICAL TO */ 
		/* 0xF1 */ 0x064B, /* ARABIC FATHATAN */ 
		/* 0xF2 */ 0x064C, /* ARABIC DAMMATAN */ 
		/* 0xF3 */ 0x064D, /* ARABIC KASRATAN */ 
		/* 0xF4 */ 0x064E, /* ARABIC FATHA */ 
		/* 0xF5 */ 0x064F, /* ARABIC DAMMA */ 
		/* 0xF6 */ 0x0650, /* ARABIC KASRA */ 
		/* 0xF7 */ 0x2248, /* ALMOST EQUAL TO */ 
		/* 0xF8 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xF9 */ 0x2219, /* BULLET OPERATOR */ 
		/* 0xFA */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xFB */ 0x221A, /* SQUARE ROOT */ 
		/* 0xFC */ 0x207F, /* SUPERSCRIPT LATIN SMALL LETTER N */ 
		/* 0xFD */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xFE */ 0x25A0, /* BLACK SQUARE */ 
		/* 0xFF */ 0x00A0, /* NO-BREAK SPACE */ 
	};

	private static char[] cp850 = {
		/* 0x80 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0x81 */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0x82 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0x83 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0x84 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0x85 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0x86 */ 0x00E5, /* LATIN SMALL LETTER A WITH RING ABOVE */ 
		/* 0x87 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0x88 */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0x89 */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0x8A */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0x8B */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0x8C */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0x8D */ 0x00EC, /* LATIN SMALL LETTER I WITH GRAVE */ 
		/* 0x8E */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0x8F */ 0x00C5, /* LATIN CAPITAL LETTER A WITH RING ABOVE */ 
		/* 0x90 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0x91 */ 0x00E6, /* LATIN SMALL LETTER AE */ 
		/* 0x92 */ 0x00C6, /* LATIN CAPITAL LETTER AE */ 
		/* 0x93 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0x94 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0x95 */ 0x00F2, /* LATIN SMALL LETTER O WITH GRAVE */ 
		/* 0x96 */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0x97 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0x98 */ 0x00FF, /* LATIN SMALL LETTER Y WITH DIAERESIS */ 
		/* 0x99 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0x9A */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0x9B */ 0x00F8, /* LATIN SMALL LETTER O WITH STROKE */ 
		/* 0x9C */ 0x00A3, /* POUND SIGN */ 
		/* 0x9D */ 0x00D8, /* LATIN CAPITAL LETTER O WITH STROKE */ 
		/* 0x9E */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0x9F */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0xA0 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xA1 */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xA2 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xA3 */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xA4 */ 0x00F1, /* LATIN SMALL LETTER N WITH TILDE */ 
		/* 0xA5 */ 0x00D1, /* LATIN CAPITAL LETTER N WITH TILDE */ 
		/* 0xA6 */ 0x00AA, /* FEMININE ORDINAL INDICATOR */ 
		/* 0xA7 */ 0x00BA, /* MASCULINE ORDINAL INDICATOR */ 
		/* 0xA8 */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xA9 */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAA */ 0x00AC, /* NOT SIGN */ 
		/* 0xAB */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xAC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xAD */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xAE */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAF */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xB0 */ 0x2591, /* LIGHT SHADE */ 
		/* 0xB1 */ 0x2592, /* MEDIUM SHADE */ 
		/* 0xB2 */ 0x2593, /* DARK SHADE */ 
		/* 0xB3 */ 0x2502, /* BOX DRAWINGS LIGHT VERTICAL */ 
		/* 0xB4 */ 0x2524, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */ 
		/* 0xB5 */ 0x00C1, /* LATIN CAPITAL LETTER A WITH ACUTE */ 
		/* 0xB6 */ 0x00C2, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */ 
		/* 0xB7 */ 0x00C0, /* LATIN CAPITAL LETTER A WITH GRAVE */ 
		/* 0xB8 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xB9 */ 0x2563, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */ 
		/* 0xBA */ 0x2551, /* BOX DRAWINGS DOUBLE VERTICAL */ 
		/* 0xBB */ 0x2557, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */ 
		/* 0xBC */ 0x255D, /* BOX DRAWINGS DOUBLE UP AND LEFT */ 
		/* 0xBD */ 0x00A2, /* CENT SIGN */ 
		/* 0xBE */ 0x00A5, /* YEN SIGN */ 
		/* 0xBF */ 0x2510, /* BOX DRAWINGS LIGHT DOWN AND LEFT */ 
		/* 0xC0 */ 0x2514, /* BOX DRAWINGS LIGHT UP AND RIGHT */ 
		/* 0xC1 */ 0x2534, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */ 
		/* 0xC2 */ 0x252C, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */ 
		/* 0xC3 */ 0x251C, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */ 
		/* 0xC4 */ 0x2500, /* BOX DRAWINGS LIGHT HORIZONTAL */ 
		/* 0xC5 */ 0x253C, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */ 
		/* 0xC6 */ 0x00E3, /* LATIN SMALL LETTER A WITH TILDE */ 
		/* 0xC7 */ 0x00C3, /* LATIN CAPITAL LETTER A WITH TILDE */ 
		/* 0xC8 */ 0x255A, /* BOX DRAWINGS DOUBLE UP AND RIGHT */ 
		/* 0xC9 */ 0x2554, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */ 
		/* 0xCA */ 0x2569, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */ 
		/* 0xCB */ 0x2566, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */ 
		/* 0xCC */ 0x2560, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */ 
		/* 0xCD */ 0x2550, /* BOX DRAWINGS DOUBLE HORIZONTAL */ 
		/* 0xCE */ 0x256C, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */ 
		/* 0xCF */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xD0 */ 0x00F0, /* LATIN SMALL LETTER ETH */ 
		/* 0xD1 */ 0x00D0, /* LATIN CAPITAL LETTER ETH */ 
		/* 0xD2 */ 0x00CA, /* LATIN CAPITAL LETTER E WITH CIRCUMFLEX */ 
		/* 0xD3 */ 0x00CB, /* LATIN CAPITAL LETTER E WITH DIAERESIS */ 
		/* 0xD4 */ 0x00C8, /* LATIN CAPITAL LETTER E WITH GRAVE */ 
		/* 0xD5 */ 0x0131, /* LATIN SMALL LETTER DOTLESS I */ 
		/* 0xD6 */ 0x00CD, /* LATIN CAPITAL LETTER I WITH ACUTE */ 
		/* 0xD7 */ 0x00CE, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */ 
		/* 0xD8 */ 0x00CF, /* LATIN CAPITAL LETTER I WITH DIAERESIS */ 
		/* 0xD9 */ 0x2518, /* BOX DRAWINGS LIGHT UP AND LEFT */ 
		/* 0xDA */ 0x250C, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */ 
		/* 0xDB */ 0x2588, /* FULL BLOCK */ 
		/* 0xDC */ 0x2584, /* LOWER HALF BLOCK */ 
		/* 0xDD */ 0x00A6, /* BROKEN BAR */ 
		/* 0xDE */ 0x00CC, /* LATIN CAPITAL LETTER I WITH GRAVE */ 
		/* 0xDF */ 0x2580, /* UPPER HALF BLOCK */ 
		/* 0xE0 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xE1 */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE2 */ 0x00D4, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x00D2, /* LATIN CAPITAL LETTER O WITH GRAVE */ 
		/* 0xE4 */ 0x00F5, /* LATIN SMALL LETTER O WITH TILDE */ 
		/* 0xE5 */ 0x00D5, /* LATIN CAPITAL LETTER O WITH TILDE */ 
		/* 0xE6 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xE7 */ 0x00FE, /* LATIN SMALL LETTER THORN */ 
		/* 0xE8 */ 0x00DE, /* LATIN CAPITAL LETTER THORN */ 
		/* 0xE9 */ 0x00DA, /* LATIN CAPITAL LETTER U WITH ACUTE */ 
		/* 0xEA */ 0x00DB, /* LATIN CAPITAL LETTER U WITH CIRCUMFLEX */ 
		/* 0xEB */ 0x00D9, /* LATIN CAPITAL LETTER U WITH GRAVE */ 
		/* 0xEC */ 0x00FD, /* LATIN SMALL LETTER Y WITH ACUTE */ 
		/* 0xED */ 0x00DD, /* LATIN CAPITAL LETTER Y WITH ACUTE */ 
		/* 0xEE */ 0x00AF, /* MACRON */ 
		/* 0xEF */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xF0 */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xF1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xF2 */ 0x2017, /* DOUBLE LOW LINE */ 
		/* 0xF3 */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xF4 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xF5 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xF6 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF7 */ 0x00B8, /* CEDILLA */ 
		/* 0xF8 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xF9 */ 0x00A8, /* DIAERESIS */ 
		/* 0xFA */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xFB */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xFC */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xFD */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xFE */ 0x25A0, /* BLACK SQUARE */ 
		/* 0xFF */ 0x00A0, /* NO-BREAK SPACE */ 
	};

	private static char[] cp852 = {
		/* 0x80 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0x81 */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0x82 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0x83 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0x84 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0x85 */ 0x016F, /* LATIN SMALL LETTER U WITH RING ABOVE */ 
		/* 0x86 */ 0x0107, /* LATIN SMALL LETTER C WITH ACUTE */ 
		/* 0x87 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0x88 */ 0x0142, /* LATIN SMALL LETTER L WITH STROKE */ 
		/* 0x89 */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0x8A */ 0x0150, /* LATIN CAPITAL LETTER O WITH DOUBLE ACUTE */ 
		/* 0x8B */ 0x0151, /* LATIN SMALL LETTER O WITH DOUBLE ACUTE */ 
		/* 0x8C */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0x8D */ 0x0179, /* LATIN CAPITAL LETTER Z WITH ACUTE */ 
		/* 0x8E */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0x8F */ 0x0106, /* LATIN CAPITAL LETTER C WITH ACUTE */ 
		/* 0x90 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0x91 */ 0x0139, /* LATIN CAPITAL LETTER L WITH ACUTE */ 
		/* 0x92 */ 0x013A, /* LATIN SMALL LETTER L WITH ACUTE */ 
		/* 0x93 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0x94 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0x95 */ 0x013D, /* LATIN CAPITAL LETTER L WITH CARON */ 
		/* 0x96 */ 0x013E, /* LATIN SMALL LETTER L WITH CARON */ 
		/* 0x97 */ 0x015A, /* LATIN CAPITAL LETTER S WITH ACUTE */ 
		/* 0x98 */ 0x015B, /* LATIN SMALL LETTER S WITH ACUTE */ 
		/* 0x99 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0x9A */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0x9B */ 0x0164, /* LATIN CAPITAL LETTER T WITH CARON */ 
		/* 0x9C */ 0x0165, /* LATIN SMALL LETTER T WITH CARON */ 
		/* 0x9D */ 0x0141, /* LATIN CAPITAL LETTER L WITH STROKE */ 
		/* 0x9E */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0x9F */ 0x010D, /* LATIN SMALL LETTER C WITH CARON */ 
		/* 0xA0 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xA1 */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xA2 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xA3 */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xA4 */ 0x0104, /* LATIN CAPITAL LETTER A WITH OGONEK */ 
		/* 0xA5 */ 0x0105, /* LATIN SMALL LETTER A WITH OGONEK */ 
		/* 0xA6 */ 0x017D, /* LATIN CAPITAL LETTER Z WITH CARON */ 
		/* 0xA7 */ 0x017E, /* LATIN SMALL LETTER Z WITH CARON */ 
		/* 0xA8 */ 0x0118, /* LATIN CAPITAL LETTER E WITH OGONEK */ 
		/* 0xA9 */ 0x0119, /* LATIN SMALL LETTER E WITH OGONEK */ 
		/* 0xAA */ 0x00AC, /* NOT SIGN */ 
		/* 0xAB */ 0x017A, /* LATIN SMALL LETTER Z WITH ACUTE */ 
		/* 0xAC */ 0x010C, /* LATIN CAPITAL LETTER C WITH CARON */ 
		/* 0xAD */ 0x015F, /* LATIN SMALL LETTER S WITH CEDILLA */ 
		/* 0xAE */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAF */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xB0 */ 0x2591, /* LIGHT SHADE */ 
		/* 0xB1 */ 0x2592, /* MEDIUM SHADE */ 
		/* 0xB2 */ 0x2593, /* DARK SHADE */ 
		/* 0xB3 */ 0x2502, /* BOX DRAWINGS LIGHT VERTICAL */ 
		/* 0xB4 */ 0x2524, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */ 
		/* 0xB5 */ 0x00C1, /* LATIN CAPITAL LETTER A WITH ACUTE */ 
		/* 0xB6 */ 0x00C2, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */ 
		/* 0xB7 */ 0x011A, /* LATIN CAPITAL LETTER E WITH CARON */ 
		/* 0xB8 */ 0x015E, /* LATIN CAPITAL LETTER S WITH CEDILLA */ 
		/* 0xB9 */ 0x2563, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */ 
		/* 0xBA */ 0x2551, /* BOX DRAWINGS DOUBLE VERTICAL */ 
		/* 0xBB */ 0x2557, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */ 
		/* 0xBC */ 0x255D, /* BOX DRAWINGS DOUBLE UP AND LEFT */ 
		/* 0xBD */ 0x017B, /* LATIN CAPITAL LETTER Z WITH DOT ABOVE */ 
		/* 0xBE */ 0x017C, /* LATIN SMALL LETTER Z WITH DOT ABOVE */ 
		/* 0xBF */ 0x2510, /* BOX DRAWINGS LIGHT DOWN AND LEFT */ 
		/* 0xC0 */ 0x2514, /* BOX DRAWINGS LIGHT UP AND RIGHT */ 
		/* 0xC1 */ 0x2534, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */ 
		/* 0xC2 */ 0x252C, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */ 
		/* 0xC3 */ 0x251C, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */ 
		/* 0xC4 */ 0x2500, /* BOX DRAWINGS LIGHT HORIZONTAL */ 
		/* 0xC5 */ 0x253C, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */ 
		/* 0xC6 */ 0x0102, /* LATIN CAPITAL LETTER A WITH BREVE */ 
		/* 0xC7 */ 0x0103, /* LATIN SMALL LETTER A WITH BREVE */ 
		/* 0xC8 */ 0x255A, /* BOX DRAWINGS DOUBLE UP AND RIGHT */ 
		/* 0xC9 */ 0x2554, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */ 
		/* 0xCA */ 0x2569, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */ 
		/* 0xCB */ 0x2566, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */ 
		/* 0xCC */ 0x2560, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */ 
		/* 0xCD */ 0x2550, /* BOX DRAWINGS DOUBLE HORIZONTAL */ 
		/* 0xCE */ 0x256C, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */ 
		/* 0xCF */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xD0 */ 0x0111, /* LATIN SMALL LETTER D WITH STROKE */ 
		/* 0xD1 */ 0x0110, /* LATIN CAPITAL LETTER D WITH STROKE */ 
		/* 0xD2 */ 0x010E, /* LATIN CAPITAL LETTER D WITH CARON */ 
		/* 0xD3 */ 0x00CB, /* LATIN CAPITAL LETTER E WITH DIAERESIS */ 
		/* 0xD4 */ 0x010F, /* LATIN SMALL LETTER D WITH CARON */ 
		/* 0xD5 */ 0x0147, /* LATIN CAPITAL LETTER N WITH CARON */ 
		/* 0xD6 */ 0x00CD, /* LATIN CAPITAL LETTER I WITH ACUTE */ 
		/* 0xD7 */ 0x00CE, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */ 
		/* 0xD8 */ 0x011B, /* LATIN SMALL LETTER E WITH CARON */ 
		/* 0xD9 */ 0x2518, /* BOX DRAWINGS LIGHT UP AND LEFT */ 
		/* 0xDA */ 0x250C, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */ 
		/* 0xDB */ 0x2588, /* FULL BLOCK */ 
		/* 0xDC */ 0x2584, /* LOWER HALF BLOCK */ 
		/* 0xDD */ 0x0162, /* LATIN CAPITAL LETTER T WITH CEDILLA */ 
		/* 0xDE */ 0x016E, /* LATIN CAPITAL LETTER U WITH RING ABOVE */ 
		/* 0xDF */ 0x2580, /* UPPER HALF BLOCK */ 
		/* 0xE0 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xE1 */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE2 */ 0x00D4, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x0143, /* LATIN CAPITAL LETTER N WITH ACUTE */ 
		/* 0xE4 */ 0x0144, /* LATIN SMALL LETTER N WITH ACUTE */ 
		/* 0xE5 */ 0x0148, /* LATIN SMALL LETTER N WITH CARON */ 
		/* 0xE6 */ 0x0160, /* LATIN CAPITAL LETTER S WITH CARON */ 
		/* 0xE7 */ 0x0161, /* LATIN SMALL LETTER S WITH CARON */ 
		/* 0xE8 */ 0x0154, /* LATIN CAPITAL LETTER R WITH ACUTE */ 
		/* 0xE9 */ 0x00DA, /* LATIN CAPITAL LETTER U WITH ACUTE */ 
		/* 0xEA */ 0x0155, /* LATIN SMALL LETTER R WITH ACUTE */ 
		/* 0xEB */ 0x0170, /* LATIN CAPITAL LETTER U WITH DOUBLE ACUTE */ 
		/* 0xEC */ 0x00FD, /* LATIN SMALL LETTER Y WITH ACUTE */ 
		/* 0xED */ 0x00DD, /* LATIN CAPITAL LETTER Y WITH ACUTE */ 
		/* 0xEE */ 0x0163, /* LATIN SMALL LETTER T WITH CEDILLA */ 
		/* 0xEF */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xF0 */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xF1 */ 0x02DD, /* DOUBLE ACUTE ACCENT */ 
		/* 0xF2 */ 0x02DB, /* OGONEK */ 
		/* 0xF3 */ 0x02C7, /* CARON */ 
		/* 0xF4 */ 0x02D8, /* BREVE */ 
		/* 0xF5 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xF6 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF7 */ 0x00B8, /* CEDILLA */ 
		/* 0xF8 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xF9 */ 0x00A8, /* DIAERESIS */ 
		/* 0xFA */ 0x02D9, /* DOT ABOVE */ 
		/* 0xFB */ 0x0171, /* LATIN SMALL LETTER U WITH DOUBLE ACUTE */ 
		/* 0xFC */ 0x0158, /* LATIN CAPITAL LETTER R WITH CARON */ 
		/* 0xFD */ 0x0159, /* LATIN SMALL LETTER R WITH CARON */ 
		/* 0xFE */ 0x25A0, /* BLACK SQUARE */ 
		/* 0xFF */ 0x00A0, /* NO-BREAK SPACE  */ 
	};

	private static char[] cp862 = {
		/* 0x80 */ 0x05D0, /* HEBREW LETTER ALEF */ 
		/* 0x81 */ 0x05D1, /* HEBREW LETTER BET */ 
		/* 0x82 */ 0x05D2, /* HEBREW LETTER GIMEL */ 
		/* 0x83 */ 0x05D3, /* HEBREW LETTER DALET */ 
		/* 0x84 */ 0x05D4, /* HEBREW LETTER HE */ 
		/* 0x85 */ 0x05D5, /* HEBREW LETTER VAV */ 
		/* 0x86 */ 0x05D6, /* HEBREW LETTER ZAYIN */ 
		/* 0x87 */ 0x05D7, /* HEBREW LETTER HET */ 
		/* 0x88 */ 0x05D8, /* HEBREW LETTER TET */ 
		/* 0x89 */ 0x05D9, /* HEBREW LETTER YOD */ 
		/* 0x8A */ 0x05DA, /* HEBREW LETTER FINAL KAF */ 
		/* 0x8B */ 0x05DB, /* HEBREW LETTER KAF */ 
		/* 0x8C */ 0x05DC, /* HEBREW LETTER LAMED */ 
		/* 0x8D */ 0x05DD, /* HEBREW LETTER FINAL MEM */ 
		/* 0x8E */ 0x05DE, /* HEBREW LETTER MEM */ 
		/* 0x8F */ 0x05DF, /* HEBREW LETTER FINAL NUN */ 
		/* 0x90 */ 0x05E0, /* HEBREW LETTER NUN */ 
		/* 0x91 */ 0x05E1, /* HEBREW LETTER SAMEKH */ 
		/* 0x92 */ 0x05E2, /* HEBREW LETTER AYIN */ 
		/* 0x93 */ 0x05E3, /* HEBREW LETTER FINAL PE */ 
		/* 0x94 */ 0x05E4, /* HEBREW LETTER PE */ 
		/* 0x95 */ 0x05E5, /* HEBREW LETTER FINAL TSADI */ 
		/* 0x96 */ 0x05E6, /* HEBREW LETTER TSADI */ 
		/* 0x97 */ 0x05E7, /* HEBREW LETTER QOF */ 
		/* 0x98 */ 0x05E8, /* HEBREW LETTER RESH */ 
		/* 0x99 */ 0x05E9, /* HEBREW LETTER SHIN */ 
		/* 0x9A */ 0x05EA, /* HEBREW LETTER TAV */ 
		/* 0x9B */ 0x00A2, /* CENT SIGN */ 
		/* 0x9C */ 0x00A3, /* POUND SIGN */ 
		/* 0x9D */ 0x00A5, /* YEN SIGN */ 
		/* 0x9E */ 0x20A7, /* PESETA SIGN */ 
		/* 0x9F */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0xA0 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xA1 */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xA2 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xA3 */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xA4 */ 0x00F1, /* LATIN SMALL LETTER N WITH TILDE */ 
		/* 0xA5 */ 0x00D1, /* LATIN CAPITAL LETTER N WITH TILDE */ 
		/* 0xA6 */ 0x00AA, /* FEMININE ORDINAL INDICATOR */ 
		/* 0xA7 */ 0x00BA, /* MASCULINE ORDINAL INDICATOR */ 
		/* 0xA8 */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xA9 */ 0x2310, /* REVERSED NOT SIGN */ 
		/* 0xAA */ 0x00AC, /* NOT SIGN */ 
		/* 0xAB */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xAC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xAD */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xAE */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAF */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xB0 */ 0x2591, /* LIGHT SHADE */ 
		/* 0xB1 */ 0x2592, /* MEDIUM SHADE */ 
		/* 0xB2 */ 0x2593, /* DARK SHADE */ 
		/* 0xB3 */ 0x2502, /* BOX DRAWINGS LIGHT VERTICAL */ 
		/* 0xB4 */ 0x2524, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */ 
		/* 0xB5 */ 0x2561, /* BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE */ 
		/* 0xB6 */ 0x2562, /* BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE */ 
		/* 0xB7 */ 0x2556, /* BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE */ 
		/* 0xB8 */ 0x2555, /* BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE */ 
		/* 0xB9 */ 0x2563, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */ 
		/* 0xBA */ 0x2551, /* BOX DRAWINGS DOUBLE VERTICAL */ 
		/* 0xBB */ 0x2557, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */ 
		/* 0xBC */ 0x255D, /* BOX DRAWINGS DOUBLE UP AND LEFT */ 
		/* 0xBD */ 0x255C, /* BOX DRAWINGS UP DOUBLE AND LEFT SINGLE */ 
		/* 0xBE */ 0x255B, /* BOX DRAWINGS UP SINGLE AND LEFT DOUBLE */ 
		/* 0xBF */ 0x2510, /* BOX DRAWINGS LIGHT DOWN AND LEFT */ 
		/* 0xC0 */ 0x2514, /* BOX DRAWINGS LIGHT UP AND RIGHT */ 
		/* 0xC1 */ 0x2534, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */ 
		/* 0xC2 */ 0x252C, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */ 
		/* 0xC3 */ 0x251C, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */ 
		/* 0xC4 */ 0x2500, /* BOX DRAWINGS LIGHT HORIZONTAL */ 
		/* 0xC5 */ 0x253C, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */ 
		/* 0xC6 */ 0x255E, /* BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE */ 
		/* 0xC7 */ 0x255F, /* BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE */ 
		/* 0xC8 */ 0x255A, /* BOX DRAWINGS DOUBLE UP AND RIGHT */ 
		/* 0xC9 */ 0x2554, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */ 
		/* 0xCA */ 0x2569, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */ 
		/* 0xCB */ 0x2566, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */ 
		/* 0xCC */ 0x2560, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */ 
		/* 0xCD */ 0x2550, /* BOX DRAWINGS DOUBLE HORIZONTAL */ 
		/* 0xCE */ 0x256C, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */ 
		/* 0xCF */ 0x2567, /* BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD0 */ 0x2568, /* BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD1 */ 0x2564, /* BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD2 */ 0x2565, /* BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD3 */ 0x2559, /* BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE */ 
		/* 0xD4 */ 0x2558, /* BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE */ 
		/* 0xD5 */ 0x2552, /* BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE */ 
		/* 0xD6 */ 0x2553, /* BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE */ 
		/* 0xD7 */ 0x256B, /* BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD8 */ 0x256A, /* BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD9 */ 0x2518, /* BOX DRAWINGS LIGHT UP AND LEFT */ 
		/* 0xDA */ 0x250C, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */ 
		/* 0xDB */ 0x2588, /* FULL BLOCK */ 
		/* 0xDC */ 0x2584, /* LOWER HALF BLOCK */ 
		/* 0xDD */ 0x258C, /* LEFT HALF BLOCK */ 
		/* 0xDE */ 0x2590, /* RIGHT HALF BLOCK */ 
		/* 0xDF */ 0x2580, /* UPPER HALF BLOCK */ 
		/* 0xE0 */ 0x03B1, /* GREEK SMALL LETTER ALPHA */ 
		/* 0xE1 */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE2 */ 0x0393, /* GREEK CAPITAL LETTER GAMMA */ 
		/* 0xE3 */ 0x03C0, /* GREEK SMALL LETTER PI */ 
		/* 0xE4 */ 0x03A3, /* GREEK CAPITAL LETTER SIGMA */ 
		/* 0xE5 */ 0x03C3, /* GREEK SMALL LETTER SIGMA */ 
		/* 0xE6 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xE7 */ 0x03C4, /* GREEK SMALL LETTER TAU */ 
		/* 0xE8 */ 0x03A6, /* GREEK CAPITAL LETTER PHI */ 
		/* 0xE9 */ 0x0398, /* GREEK CAPITAL LETTER THETA */ 
		/* 0xEA */ 0x03A9, /* GREEK CAPITAL LETTER OMEGA */ 
		/* 0xEB */ 0x03B4, /* GREEK SMALL LETTER DELTA */ 
		/* 0xEC */ 0x221E, /* INFINITY */ 
		/* 0xED */ 0x03C6, /* GREEK SMALL LETTER PHI */ 
		/* 0xEE */ 0x03B5, /* GREEK SMALL LETTER EPSILON */ 
		/* 0xEF */ 0x2229, /* INTERSECTION */ 
		/* 0xF0 */ 0x2261, /* IDENTICAL TO */ 
		/* 0xF1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xF2 */ 0x2265, /* GREATER-THAN OR EQUAL TO */ 
		/* 0xF3 */ 0x2264, /* LESS-THAN OR EQUAL TO */ 
		/* 0xF4 */ 0x2320, /* TOP HALF INTEGRAL */ 
		/* 0xF5 */ 0x2321, /* BOTTOM HALF INTEGRAL */ 
		/* 0xF6 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF7 */ 0x2248, /* ALMOST EQUAL TO */ 
		/* 0xF8 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xF9 */ 0x2219, /* BULLET OPERATOR */ 
		/* 0xFA */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xFB */ 0x221A, /* SQUARE ROOT */ 
		/* 0xFC */ 0x207F, /* SUPERSCRIPT LATIN SMALL LETTER N */ 
		/* 0xFD */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xFE */ 0x25A0, /* BLACK SQUARE */ 
		/* 0xFF */ 0x00A0, /* NO-BREAK SPACE  */ 
	};

	private static char[] cp866 = {
		/* 0x80 */ 0x0410, /* CYRILLIC CAPITAL LETTER A */ 
		/* 0x81 */ 0x0411, /* CYRILLIC CAPITAL LETTER BE */ 
		/* 0x82 */ 0x0412, /* CYRILLIC CAPITAL LETTER VE */ 
		/* 0x83 */ 0x0413, /* CYRILLIC CAPITAL LETTER GHE */ 
		/* 0x84 */ 0x0414, /* CYRILLIC CAPITAL LETTER DE */ 
		/* 0x85 */ 0x0415, /* CYRILLIC CAPITAL LETTER IE */ 
		/* 0x86 */ 0x0416, /* CYRILLIC CAPITAL LETTER ZHE */ 
		/* 0x87 */ 0x0417, /* CYRILLIC CAPITAL LETTER ZE */ 
		/* 0x88 */ 0x0418, /* CYRILLIC CAPITAL LETTER I */ 
		/* 0x89 */ 0x0419, /* CYRILLIC CAPITAL LETTER SHORT I */ 
		/* 0x8A */ 0x041A, /* CYRILLIC CAPITAL LETTER KA */ 
		/* 0x8B */ 0x041B, /* CYRILLIC CAPITAL LETTER EL */ 
		/* 0x8C */ 0x041C, /* CYRILLIC CAPITAL LETTER EM */ 
		/* 0x8D */ 0x041D, /* CYRILLIC CAPITAL LETTER EN */ 
		/* 0x8E */ 0x041E, /* CYRILLIC CAPITAL LETTER O */ 
		/* 0x8F */ 0x041F, /* CYRILLIC CAPITAL LETTER PE */ 
		/* 0x90 */ 0x0420, /* CYRILLIC CAPITAL LETTER ER */ 
		/* 0x91 */ 0x0421, /* CYRILLIC CAPITAL LETTER ES */ 
		/* 0x92 */ 0x0422, /* CYRILLIC CAPITAL LETTER TE */ 
		/* 0x93 */ 0x0423, /* CYRILLIC CAPITAL LETTER U */ 
		/* 0x94 */ 0x0424, /* CYRILLIC CAPITAL LETTER EF */ 
		/* 0x95 */ 0x0425, /* CYRILLIC CAPITAL LETTER HA */ 
		/* 0x96 */ 0x0426, /* CYRILLIC CAPITAL LETTER TSE */ 
		/* 0x97 */ 0x0427, /* CYRILLIC CAPITAL LETTER CHE */ 
		/* 0x98 */ 0x0428, /* CYRILLIC CAPITAL LETTER SHA */ 
		/* 0x99 */ 0x0429, /* CYRILLIC CAPITAL LETTER SHCHA */ 
		/* 0x9A */ 0x042A, /* CYRILLIC CAPITAL LETTER HARD SIGN */ 
		/* 0x9B */ 0x042B, /* CYRILLIC CAPITAL LETTER YERU */ 
		/* 0x9C */ 0x042C, /* CYRILLIC CAPITAL LETTER SOFT SIGN */ 
		/* 0x9D */ 0x042D, /* CYRILLIC CAPITAL LETTER E */ 
		/* 0x9E */ 0x042E, /* CYRILLIC CAPITAL LETTER YU */ 
		/* 0x9F */ 0x042F, /* CYRILLIC CAPITAL LETTER YA */ 
		/* 0xA0 */ 0x0430, /* CYRILLIC SMALL LETTER A */ 
		/* 0xA1 */ 0x0431, /* CYRILLIC SMALL LETTER BE */ 
		/* 0xA2 */ 0x0432, /* CYRILLIC SMALL LETTER VE */ 
		/* 0xA3 */ 0x0433, /* CYRILLIC SMALL LETTER GHE */ 
		/* 0xA4 */ 0x0434, /* CYRILLIC SMALL LETTER DE */ 
		/* 0xA5 */ 0x0435, /* CYRILLIC SMALL LETTER IE */ 
		/* 0xA6 */ 0x0436, /* CYRILLIC SMALL LETTER ZHE */ 
		/* 0xA7 */ 0x0437, /* CYRILLIC SMALL LETTER ZE */ 
		/* 0xA8 */ 0x0438, /* CYRILLIC SMALL LETTER I */ 
		/* 0xA9 */ 0x0439, /* CYRILLIC SMALL LETTER SHORT I */ 
		/* 0xAA */ 0x043A, /* CYRILLIC SMALL LETTER KA */ 
		/* 0xAB */ 0x043B, /* CYRILLIC SMALL LETTER EL */ 
		/* 0xAC */ 0x043C, /* CYRILLIC SMALL LETTER EM */ 
		/* 0xAD */ 0x043D, /* CYRILLIC SMALL LETTER EN */ 
		/* 0xAE */ 0x043E, /* CYRILLIC SMALL LETTER O */ 
		/* 0xAF */ 0x043F, /* CYRILLIC SMALL LETTER PE */ 
		/* 0xB0 */ 0x2591, /* LIGHT SHADE */ 
		/* 0xB1 */ 0x2592, /* MEDIUM SHADE */ 
		/* 0xB2 */ 0x2593, /* DARK SHADE */ 
		/* 0xB3 */ 0x2502, /* BOX DRAWINGS LIGHT VERTICAL */ 
		/* 0xB4 */ 0x2524, /* BOX DRAWINGS LIGHT VERTICAL AND LEFT */ 
		/* 0xB5 */ 0x2561, /* BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE */ 
		/* 0xB6 */ 0x2562, /* BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE */ 
		/* 0xB7 */ 0x2556, /* BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE */ 
		/* 0xB8 */ 0x2555, /* BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE */ 
		/* 0xB9 */ 0x2563, /* BOX DRAWINGS DOUBLE VERTICAL AND LEFT */ 
		/* 0xBA */ 0x2551, /* BOX DRAWINGS DOUBLE VERTICAL */ 
		/* 0xBB */ 0x2557, /* BOX DRAWINGS DOUBLE DOWN AND LEFT */ 
		/* 0xBC */ 0x255D, /* BOX DRAWINGS DOUBLE UP AND LEFT */ 
		/* 0xBD */ 0x255C, /* BOX DRAWINGS UP DOUBLE AND LEFT SINGLE */ 
		/* 0xBE */ 0x255B, /* BOX DRAWINGS UP SINGLE AND LEFT DOUBLE */ 
		/* 0xBF */ 0x2510, /* BOX DRAWINGS LIGHT DOWN AND LEFT */ 
		/* 0xC0 */ 0x2514, /* BOX DRAWINGS LIGHT UP AND RIGHT */ 
		/* 0xC1 */ 0x2534, /* BOX DRAWINGS LIGHT UP AND HORIZONTAL */ 
		/* 0xC2 */ 0x252C, /* BOX DRAWINGS LIGHT DOWN AND HORIZONTAL */ 
		/* 0xC3 */ 0x251C, /* BOX DRAWINGS LIGHT VERTICAL AND RIGHT */ 
		/* 0xC4 */ 0x2500, /* BOX DRAWINGS LIGHT HORIZONTAL */ 
		/* 0xC5 */ 0x253C, /* BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL */ 
		/* 0xC6 */ 0x255E, /* BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE */ 
		/* 0xC7 */ 0x255F, /* BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE */ 
		/* 0xC8 */ 0x255A, /* BOX DRAWINGS DOUBLE UP AND RIGHT */ 
		/* 0xC9 */ 0x2554, /* BOX DRAWINGS DOUBLE DOWN AND RIGHT */ 
		/* 0xCA */ 0x2569, /* BOX DRAWINGS DOUBLE UP AND HORIZONTAL */ 
		/* 0xCB */ 0x2566, /* BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL */ 
		/* 0xCC */ 0x2560, /* BOX DRAWINGS DOUBLE VERTICAL AND RIGHT */ 
		/* 0xCD */ 0x2550, /* BOX DRAWINGS DOUBLE HORIZONTAL */ 
		/* 0xCE */ 0x256C, /* BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL */ 
		/* 0xCF */ 0x2567, /* BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD0 */ 0x2568, /* BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD1 */ 0x2564, /* BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD2 */ 0x2565, /* BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD3 */ 0x2559, /* BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE */ 
		/* 0xD4 */ 0x2558, /* BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE */ 
		/* 0xD5 */ 0x2552, /* BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE */ 
		/* 0xD6 */ 0x2553, /* BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE */ 
		/* 0xD7 */ 0x256B, /* BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE */ 
		/* 0xD8 */ 0x256A, /* BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE */ 
		/* 0xD9 */ 0x2518, /* BOX DRAWINGS LIGHT UP AND LEFT */ 
		/* 0xDA */ 0x250C, /* BOX DRAWINGS LIGHT DOWN AND RIGHT */ 
		/* 0xDB */ 0x2588, /* FULL BLOCK */ 
		/* 0xDC */ 0x2584, /* LOWER HALF BLOCK */ 
		/* 0xDD */ 0x258C, /* LEFT HALF BLOCK */ 
		/* 0xDE */ 0x2590, /* RIGHT HALF BLOCK */ 
		/* 0xDF */ 0x2580, /* UPPER HALF BLOCK */ 
		/* 0xE0 */ 0x0440, /* CYRILLIC SMALL LETTER ER */ 
		/* 0xE1 */ 0x0441, /* CYRILLIC SMALL LETTER ES */ 
		/* 0xE2 */ 0x0442, /* CYRILLIC SMALL LETTER TE */ 
		/* 0xE3 */ 0x0443, /* CYRILLIC SMALL LETTER U */ 
		/* 0xE4 */ 0x0444, /* CYRILLIC SMALL LETTER EF */ 
		/* 0xE5 */ 0x0445, /* CYRILLIC SMALL LETTER HA */ 
		/* 0xE6 */ 0x0446, /* CYRILLIC SMALL LETTER TSE */ 
		/* 0xE7 */ 0x0447, /* CYRILLIC SMALL LETTER CHE */ 
		/* 0xE8 */ 0x0448, /* CYRILLIC SMALL LETTER SHA */ 
		/* 0xE9 */ 0x0449, /* CYRILLIC SMALL LETTER SHCHA */ 
		/* 0xEA */ 0x044A, /* CYRILLIC SMALL LETTER HARD SIGN */ 
		/* 0xEB */ 0x044B, /* CYRILLIC SMALL LETTER YERU */ 
		/* 0xEC */ 0x044C, /* CYRILLIC SMALL LETTER SOFT SIGN */ 
		/* 0xED */ 0x044D, /* CYRILLIC SMALL LETTER E */ 
		/* 0xEE */ 0x044E, /* CYRILLIC SMALL LETTER YU */ 
		/* 0xEF */ 0x044F, /* CYRILLIC SMALL LETTER YA */ 
		/* 0xF0 */ 0x0401, /* CYRILLIC CAPITAL LETTER IO */ 
		/* 0xF1 */ 0x0451, /* CYRILLIC SMALL LETTER IO */ 
		/* 0xF2 */ 0x0404, /* CYRILLIC CAPITAL LETTER UKRAINIAN IE */ 
		/* 0xF3 */ 0x0454, /* CYRILLIC SMALL LETTER UKRAINIAN IE */ 
		/* 0xF4 */ 0x0407, /* CYRILLIC CAPITAL LETTER YI */ 
		/* 0xF5 */ 0x0457, /* CYRILLIC SMALL LETTER YI */ 
		/* 0xF6 */ 0x040E, /* CYRILLIC CAPITAL LETTER SHORT U */ 
		/* 0xF7 */ 0x045E, /* CYRILLIC SMALL LETTER SHORT U */ 
		/* 0xF8 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xF9 */ 0x2219, /* BULLET OPERATOR */ 
		/* 0xFA */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xFB */ 0x221A, /* SQUARE ROOT */ 
		/* 0xFC */ 0x2116, /* NUMERO SIGN */ 
		/* 0xFD */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xFE */ 0x25A0, /* BLACK SQUARE */ 
		/* 0xFF */ 0x00A0, /* NO-BREAK SPACE  */ 
	};

	private static char[] cp874 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */			0x20,
		/* 0x83 */			0x20,
		/* 0x84 */			0x20,
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */			0x20,
		/* 0x87 */			0x20,
		/* 0x88 */			0x20,
		/* 0x89 */			0x20,
		/* 0x8A */			0x20,
		/* 0x8B */			0x20,
		/* 0x8C */			0x20,
		/* 0x8D */			0x20,
		/* 0x8E */			0x20,
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */			0x20,
		/* 0x99 */			0x20,
		/* 0x9A */			0x20,
		/* 0x9B */			0x20,
		/* 0x9C */			0x20,
		/* 0x9D */			0x20,
		/* 0x9E */			0x20,
		/* 0x9F */			0x20,
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x0E01, /* THAI CHARACTER KO KAI */ 
		/* 0xA2 */ 0x0E02, /* THAI CHARACTER KHO KHAI */ 
		/* 0xA3 */ 0x0E03, /* THAI CHARACTER KHO KHUAT */ 
		/* 0xA4 */ 0x0E04, /* THAI CHARACTER KHO KHWAI */ 
		/* 0xA5 */ 0x0E05, /* THAI CHARACTER KHO KHON */ 
		/* 0xA6 */ 0x0E06, /* THAI CHARACTER KHO RAKHANG */ 
		/* 0xA7 */ 0x0E07, /* THAI CHARACTER NGO NGU */ 
		/* 0xA8 */ 0x0E08, /* THAI CHARACTER CHO CHAN */ 
		/* 0xA9 */ 0x0E09, /* THAI CHARACTER CHO CHING */ 
		/* 0xAA */ 0x0E0A, /* THAI CHARACTER CHO CHANG */ 
		/* 0xAB */ 0x0E0B, /* THAI CHARACTER SO SO */ 
		/* 0xAC */ 0x0E0C, /* THAI CHARACTER CHO CHOE */ 
		/* 0xAD */ 0x0E0D, /* THAI CHARACTER YO YING */ 
		/* 0xAE */ 0x0E0E, /* THAI CHARACTER DO CHADA */ 
		/* 0xAF */ 0x0E0F, /* THAI CHARACTER TO PATAK */ 
		/* 0xB0 */ 0x0E10, /* THAI CHARACTER THO THAN */ 
		/* 0xB1 */ 0x0E11, /* THAI CHARACTER THO NANGMONTHO */ 
		/* 0xB2 */ 0x0E12, /* THAI CHARACTER THO PHUTHAO */ 
		/* 0xB3 */ 0x0E13, /* THAI CHARACTER NO NEN */ 
		/* 0xB4 */ 0x0E14, /* THAI CHARACTER DO DEK */ 
		/* 0xB5 */ 0x0E15, /* THAI CHARACTER TO TAO */ 
		/* 0xB6 */ 0x0E16, /* THAI CHARACTER THO THUNG */ 
		/* 0xB7 */ 0x0E17, /* THAI CHARACTER THO THAHAN */ 
		/* 0xB8 */ 0x0E18, /* THAI CHARACTER THO THONG */ 
		/* 0xB9 */ 0x0E19, /* THAI CHARACTER NO NU */ 
		/* 0xBA */ 0x0E1A, /* THAI CHARACTER BO BAIMAI */ 
		/* 0xBB */ 0x0E1B, /* THAI CHARACTER PO PLA */ 
		/* 0xBC */ 0x0E1C, /* THAI CHARACTER PHO PHUNG */ 
		/* 0xBD */ 0x0E1D, /* THAI CHARACTER FO FA */ 
		/* 0xBE */ 0x0E1E, /* THAI CHARACTER PHO PHAN */ 
		/* 0xBF */ 0x0E1F, /* THAI CHARACTER FO FAN */ 
		/* 0xC0 */ 0x0E20, /* THAI CHARACTER PHO SAMPHAO */ 
		/* 0xC1 */ 0x0E21, /* THAI CHARACTER MO MA */ 
		/* 0xC2 */ 0x0E22, /* THAI CHARACTER YO YAK */ 
		/* 0xC3 */ 0x0E23, /* THAI CHARACTER RO RUA */ 
		/* 0xC4 */ 0x0E24, /* THAI CHARACTER RU */ 
		/* 0xC5 */ 0x0E25, /* THAI CHARACTER LO LING */ 
		/* 0xC6 */ 0x0E26, /* THAI CHARACTER LU */ 
		/* 0xC7 */ 0x0E27, /* THAI CHARACTER WO WAEN */ 
		/* 0xC8 */ 0x0E28, /* THAI CHARACTER SO SALA */ 
		/* 0xC9 */ 0x0E29, /* THAI CHARACTER SO RUSI */ 
		/* 0xCA */ 0x0E2A, /* THAI CHARACTER SO SUA */ 
		/* 0xCB */ 0x0E2B, /* THAI CHARACTER HO HIP */ 
		/* 0xCC */ 0x0E2C, /* THAI CHARACTER LO CHULA */ 
		/* 0xCD */ 0x0E2D, /* THAI CHARACTER O ANG */ 
		/* 0xCE */ 0x0E2E, /* THAI CHARACTER HO NOKHUK */ 
		/* 0xCF */ 0x0E2F, /* THAI CHARACTER PAIYANNOI */ 
		/* 0xD0 */ 0x0E30, /* THAI CHARACTER SARA A */ 
		/* 0xD1 */ 0x0E31, /* THAI CHARACTER MAI HAN-AKAT */ 
		/* 0xD2 */ 0x0E32, /* THAI CHARACTER SARA AA */ 
		/* 0xD3 */ 0x0E33, /* THAI CHARACTER SARA AM */ 
		/* 0xD4 */ 0x0E34, /* THAI CHARACTER SARA I */ 
		/* 0xD5 */ 0x0E35, /* THAI CHARACTER SARA II */ 
		/* 0xD6 */ 0x0E36, /* THAI CHARACTER SARA UE */ 
		/* 0xD7 */ 0x0E37, /* THAI CHARACTER SARA UEE */ 
		/* 0xD8 */ 0x0E38, /* THAI CHARACTER SARA U */ 
		/* 0xD9 */ 0x0E39, /* THAI CHARACTER SARA UU */ 
		/* 0xDA */ 0x0E3A, /* THAI CHARACTER PHINTHU */ 
		/* 0xDB */			0x20,
		/* 0xDC */			0x20,
		/* 0xDD */			0x20,
		/* 0xDE */			0x20,
		/* 0xDF */ 0x0E3F, /* THAI CURRENCY SYMBOL BAHT */ 
		/* 0xE0 */ 0x0E40, /* THAI CHARACTER SARA E */ 
		/* 0xE1 */ 0x0E41, /* THAI CHARACTER SARA AE */ 
		/* 0xE2 */ 0x0E42, /* THAI CHARACTER SARA O */ 
		/* 0xE3 */ 0x0E43, /* THAI CHARACTER SARA AI MAIMUAN */ 
		/* 0xE4 */ 0x0E44, /* THAI CHARACTER SARA AI MAIMALAI */ 
		/* 0xE5 */ 0x0E45, /* THAI CHARACTER LAKKHANGYAO */ 
		/* 0xE6 */ 0x0E46, /* THAI CHARACTER MAIYAMOK */ 
		/* 0xE7 */ 0x0E47, /* THAI CHARACTER MAITAIKHU */ 
		/* 0xE8 */ 0x0E48, /* THAI CHARACTER MAI EK */ 
		/* 0xE9 */ 0x0E49, /* THAI CHARACTER MAI THO */ 
		/* 0xEA */ 0x0E4A, /* THAI CHARACTER MAI TRI */ 
		/* 0xEB */ 0x0E4B, /* THAI CHARACTER MAI CHATTAWA */ 
		/* 0xEC */ 0x0E4C, /* THAI CHARACTER THANTHAKHAT */ 
		/* 0xED */ 0x0E4D, /* THAI CHARACTER NIKHAHIT */ 
		/* 0xEE */ 0x0E4E, /* THAI CHARACTER YAMAKKAN */ 
		/* 0xEF */ 0x0E4F, /* THAI CHARACTER FONGMAN */ 
		/* 0xF0 */ 0x0E50, /* THAI DIGIT ZERO */ 
		/* 0xF1 */ 0x0E51, /* THAI DIGIT ONE */ 
		/* 0xF2 */ 0x0E52, /* THAI DIGIT TWO */ 
		/* 0xF3 */ 0x0E53, /* THAI DIGIT THREE */ 
		/* 0xF4 */ 0x0E54, /* THAI DIGIT FOUR */ 
		/* 0xF5 */ 0x0E55, /* THAI DIGIT FIVE */ 
		/* 0xF6 */ 0x0E56, /* THAI DIGIT SIX */ 
		/* 0xF7 */ 0x0E57, /* THAI DIGIT SEVEN */ 
		/* 0xF8 */ 0x0E58, /* THAI DIGIT EIGHT */ 
		/* 0xF9 */ 0x0E59, /* THAI DIGIT NINE */ 
		/* 0xFA */ 0x0E5A, /* THAI CHARACTER ANGKHANKHU */ 
		/* 0xFB */ 0x0E5B, /* THAI CHARACTER KHOMUT */ 
		/* 0xFC */			0x20,
		/* 0xFD */			0x20,
		/* 0xFE */			0x20,
		/* 0xFF */			0x20,
	};

	private static char[] cp1250 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */			0x20,
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */			0x20,
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */ 0x0160, /* LATIN CAPITAL LETTER S WITH CARON */ 
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */ 0x015A, /* LATIN CAPITAL LETTER S WITH ACUTE */ 
		/* 0x8D */ 0x0164, /* LATIN CAPITAL LETTER T WITH CARON */ 
		/* 0x8E */ 0x017D, /* LATIN CAPITAL LETTER Z WITH CARON */ 
		/* 0x8F */ 0x0179, /* LATIN CAPITAL LETTER Z WITH ACUTE */ 
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */			0x20,
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */ 0x0161, /* LATIN SMALL LETTER S WITH CARON */ 
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */ 0x015B, /* LATIN SMALL LETTER S WITH ACUTE */ 
		/* 0x9D */ 0x0165, /* LATIN SMALL LETTER T WITH CARON */ 
		/* 0x9E */ 0x017E, /* LATIN SMALL LETTER Z WITH CARON */ 
		/* 0x9F */ 0x017A, /* LATIN SMALL LETTER Z WITH ACUTE */ 
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x02C7, /* CARON */ 
		/* 0xA2 */ 0x02D8, /* BREVE */ 
		/* 0xA3 */ 0x0141, /* LATIN CAPITAL LETTER L WITH STROKE */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x0104, /* LATIN CAPITAL LETTER A WITH OGONEK */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x015E, /* LATIN CAPITAL LETTER S WITH CEDILLA */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x017B, /* LATIN CAPITAL LETTER Z WITH DOT ABOVE */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x02DB, /* OGONEK */ 
		/* 0xB3 */ 0x0142, /* LATIN SMALL LETTER L WITH STROKE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00B8, /* CEDILLA */ 
		/* 0xB9 */ 0x0105, /* LATIN SMALL LETTER A WITH OGONEK */ 
		/* 0xBA */ 0x015F, /* LATIN SMALL LETTER S WITH CEDILLA */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x013D, /* LATIN CAPITAL LETTER L WITH CARON */ 
		/* 0xBD */ 0x02DD, /* DOUBLE ACUTE ACCENT */ 
		/* 0xBE */ 0x013E, /* LATIN SMALL LETTER L WITH CARON */ 
		/* 0xBF */ 0x017C, /* LATIN SMALL LETTER Z WITH DOT ABOVE */ 
		/* 0xC0 */ 0x0154, /* LATIN CAPITAL LETTER R WITH ACUTE */ 
		/* 0xC1 */ 0x00C1, /* LATIN CAPITAL LETTER A WITH ACUTE */ 
		/* 0xC2 */ 0x00C2, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */ 
		/* 0xC3 */ 0x0102, /* LATIN CAPITAL LETTER A WITH BREVE */ 
		/* 0xC4 */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0xC5 */ 0x0139, /* LATIN CAPITAL LETTER L WITH ACUTE */ 
		/* 0xC6 */ 0x0106, /* LATIN CAPITAL LETTER C WITH ACUTE */ 
		/* 0xC7 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0xC8 */ 0x010C, /* LATIN CAPITAL LETTER C WITH CARON */ 
		/* 0xC9 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0xCA */ 0x0118, /* LATIN CAPITAL LETTER E WITH OGONEK */ 
		/* 0xCB */ 0x00CB, /* LATIN CAPITAL LETTER E WITH DIAERESIS */ 
		/* 0xCC */ 0x011A, /* LATIN CAPITAL LETTER E WITH CARON */ 
		/* 0xCD */ 0x00CD, /* LATIN CAPITAL LETTER I WITH ACUTE */ 
		/* 0xCE */ 0x00CE, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */ 
		/* 0xCF */ 0x010E, /* LATIN CAPITAL LETTER D WITH CARON */ 
		/* 0xD0 */ 0x0110, /* LATIN CAPITAL LETTER D WITH STROKE */ 
		/* 0xD1 */ 0x0143, /* LATIN CAPITAL LETTER N WITH ACUTE */ 
		/* 0xD2 */ 0x0147, /* LATIN CAPITAL LETTER N WITH CARON */ 
		/* 0xD3 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xD4 */ 0x00D4, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */ 
		/* 0xD5 */ 0x0150, /* LATIN CAPITAL LETTER O WITH DOUBLE ACUTE */ 
		/* 0xD6 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0xD7 */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xD8 */ 0x0158, /* LATIN CAPITAL LETTER R WITH CARON */ 
		/* 0xD9 */ 0x016E, /* LATIN CAPITAL LETTER U WITH RING ABOVE */ 
		/* 0xDA */ 0x00DA, /* LATIN CAPITAL LETTER U WITH ACUTE */ 
		/* 0xDB */ 0x0170, /* LATIN CAPITAL LETTER U WITH DOUBLE ACUTE */ 
		/* 0xDC */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0xDD */ 0x00DD, /* LATIN CAPITAL LETTER Y WITH ACUTE */ 
		/* 0xDE */ 0x0162, /* LATIN CAPITAL LETTER T WITH CEDILLA */ 
		/* 0xDF */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE0 */ 0x0155, /* LATIN SMALL LETTER R WITH ACUTE */ 
		/* 0xE1 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xE2 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x0103, /* LATIN SMALL LETTER A WITH BREVE */ 
		/* 0xE4 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0xE5 */ 0x013A, /* LATIN SMALL LETTER L WITH ACUTE */ 
		/* 0xE6 */ 0x0107, /* LATIN SMALL LETTER C WITH ACUTE */ 
		/* 0xE7 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0xE8 */ 0x010D, /* LATIN SMALL LETTER C WITH CARON */ 
		/* 0xE9 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0xEA */ 0x0119, /* LATIN SMALL LETTER E WITH OGONEK */ 
		/* 0xEB */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0xEC */ 0x011B, /* LATIN SMALL LETTER E WITH CARON */ 
		/* 0xED */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xEE */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0xEF */ 0x010F, /* LATIN SMALL LETTER D WITH CARON */ 
		/* 0xF0 */ 0x0111, /* LATIN SMALL LETTER D WITH STROKE */ 
		/* 0xF1 */ 0x0144, /* LATIN SMALL LETTER N WITH ACUTE */ 
		/* 0xF2 */ 0x0148, /* LATIN SMALL LETTER N WITH CARON */ 
		/* 0xF3 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xF4 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0xF5 */ 0x0151, /* LATIN SMALL LETTER O WITH DOUBLE ACUTE */ 
		/* 0xF6 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0xF7 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF8 */ 0x0159, /* LATIN SMALL LETTER R WITH CARON */ 
		/* 0xF9 */ 0x016F, /* LATIN SMALL LETTER U WITH RING ABOVE */ 
		/* 0xFA */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xFB */ 0x0171, /* LATIN SMALL LETTER U WITH DOUBLE ACUTE */ 
		/* 0xFC */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0xFD */ 0x00FD, /* LATIN SMALL LETTER Y WITH ACUTE */ 
		/* 0xFE */ 0x0163, /* LATIN SMALL LETTER T WITH CEDILLA */ 
		/* 0xFF */ 0x02D9, /* DOT ABOVE */
	};

	private static char[] cp1251 = {
		/* 0x80 */ 0x0402, /* CYRILLIC CAPITAL LETTER DJE */ 
		/* 0x81 */ 0x0403, /* CYRILLIC CAPITAL LETTER GJE */ 
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK  */
		/* 0x83 */ 0x0453, /* CYRILLIC SMALL LETTER GJE */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK  */
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */ 0x20AC, /* EURO SIGN */ 
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */ 0x0409, /* CYRILLIC CAPITAL LETTER LJE */ 
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */ 0x040A, /* CYRILLIC CAPITAL LETTER NJE */ 
		/* 0x8D */ 0x040C, /* CYRILLIC CAPITAL LETTER KJE */ 
		/* 0x8E */ 0x040B, /* CYRILLIC CAPITAL LETTER TSHE */ 
		/* 0x8F */ 0x040F, /* CYRILLIC CAPITAL LETTER DZHE */ 
		/* 0x90 */ 0x0452, /* CYRILLIC SMALL LETTER DJE */ 
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */			0x20,
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */ 0x0459, /* CYRILLIC SMALL LETTER LJE */ 
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */ 0x045A, /* CYRILLIC SMALL LETTER NJE */ 
		/* 0x9D */ 0x045C, /* CYRILLIC SMALL LETTER KJE */ 
		/* 0x9E */ 0x045B, /* CYRILLIC SMALL LETTER TSHE */ 
		/* 0x9F */ 0x045F, /* CYRILLIC SMALL LETTER DZHE */ 
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x040E, /* CYRILLIC CAPITAL LETTER SHORT U */ 
		/* 0xA2 */ 0x045E, /* CYRILLIC SMALL LETTER SHORT U */ 
		/* 0xA3 */ 0x0408, /* CYRILLIC CAPITAL LETTER JE */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x0490, /* CYRILLIC CAPITAL LETTER GHE WITH UPTURN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x0401, /* CYRILLIC CAPITAL LETTER IO */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x0404, /* CYRILLIC CAPITAL LETTER UKRAINIAN IE */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x0407, /* CYRILLIC CAPITAL LETTER YI */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x0406, /* CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I */ 
		/* 0xB3 */ 0x0456, /* CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I */ 
		/* 0xB4 */ 0x0491, /* CYRILLIC SMALL LETTER GHE WITH UPTURN */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x0451, /* CYRILLIC SMALL LETTER IO */ 
		/* 0xB9 */ 0x2116, /* NUMERO SIGN */ 
		/* 0xBA */ 0x0454, /* CYRILLIC SMALL LETTER UKRAINIAN IE */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x0458, /* CYRILLIC SMALL LETTER JE */ 
		/* 0xBD */ 0x0405, /* CYRILLIC CAPITAL LETTER DZE */ 
		/* 0xBE */ 0x0455, /* CYRILLIC SMALL LETTER DZE */ 
		/* 0xBF */ 0x0457, /* CYRILLIC SMALL LETTER YI */ 
		/* 0xC0 */ 0x0410, /* CYRILLIC CAPITAL LETTER A */ 
		/* 0xC1 */ 0x0411, /* CYRILLIC CAPITAL LETTER BE */ 
		/* 0xC2 */ 0x0412, /* CYRILLIC CAPITAL LETTER VE */ 
		/* 0xC3 */ 0x0413, /* CYRILLIC CAPITAL LETTER GHE */ 
		/* 0xC4 */ 0x0414, /* CYRILLIC CAPITAL LETTER DE */ 
		/* 0xC5 */ 0x0415, /* CYRILLIC CAPITAL LETTER IE */ 
		/* 0xC6 */ 0x0416, /* CYRILLIC CAPITAL LETTER ZHE */ 
		/* 0xC7 */ 0x0417, /* CYRILLIC CAPITAL LETTER ZE */ 
		/* 0xC8 */ 0x0418, /* CYRILLIC CAPITAL LETTER I */ 
		/* 0xC9 */ 0x0419, /* CYRILLIC CAPITAL LETTER SHORT I */ 
		/* 0xCA */ 0x041A, /* CYRILLIC CAPITAL LETTER KA */ 
		/* 0xCB */ 0x041B, /* CYRILLIC CAPITAL LETTER EL */ 
		/* 0xCC */ 0x041C, /* CYRILLIC CAPITAL LETTER EM */ 
		/* 0xCD */ 0x041D, /* CYRILLIC CAPITAL LETTER EN */ 
		/* 0xCE */ 0x041E, /* CYRILLIC CAPITAL LETTER O */ 
		/* 0xCF */ 0x041F, /* CYRILLIC CAPITAL LETTER PE */ 
		/* 0xD0 */ 0x0420, /* CYRILLIC CAPITAL LETTER ER */ 
		/* 0xD1 */ 0x0421, /* CYRILLIC CAPITAL LETTER ES */ 
		/* 0xD2 */ 0x0422, /* CYRILLIC CAPITAL LETTER TE */ 
		/* 0xD3 */ 0x0423, /* CYRILLIC CAPITAL LETTER U */ 
		/* 0xD4 */ 0x0424, /* CYRILLIC CAPITAL LETTER EF */ 
		/* 0xD5 */ 0x0425, /* CYRILLIC CAPITAL LETTER HA */ 
		/* 0xD6 */ 0x0426, /* CYRILLIC CAPITAL LETTER TSE */ 
		/* 0xD7 */ 0x0427, /* CYRILLIC CAPITAL LETTER CHE */ 
		/* 0xD8 */ 0x0428, /* CYRILLIC CAPITAL LETTER SHA */ 
		/* 0xD9 */ 0x0429, /* CYRILLIC CAPITAL LETTER SHCHA */ 
		/* 0xDA */ 0x042A, /* CYRILLIC CAPITAL LETTER HARD SIGN */ 
		/* 0xDB */ 0x042B, /* CYRILLIC CAPITAL LETTER YERU */ 
		/* 0xDC */ 0x042C, /* CYRILLIC CAPITAL LETTER SOFT SIGN */ 
		/* 0xDD */ 0x042D, /* CYRILLIC CAPITAL LETTER E */ 
		/* 0xDE */ 0x042E, /* CYRILLIC CAPITAL LETTER YU */ 
		/* 0xDF */ 0x042F, /* CYRILLIC CAPITAL LETTER YA */ 
		/* 0xE0 */ 0x0430, /* CYRILLIC SMALL LETTER A */ 
		/* 0xE1 */ 0x0431, /* CYRILLIC SMALL LETTER BE */ 
		/* 0xE2 */ 0x0432, /* CYRILLIC SMALL LETTER VE */ 
		/* 0xE3 */ 0x0433, /* CYRILLIC SMALL LETTER GHE */ 
		/* 0xE4 */ 0x0434, /* CYRILLIC SMALL LETTER DE */ 
		/* 0xE5 */ 0x0435, /* CYRILLIC SMALL LETTER IE */ 
		/* 0xE6 */ 0x0436, /* CYRILLIC SMALL LETTER ZHE */ 
		/* 0xE7 */ 0x0437, /* CYRILLIC SMALL LETTER ZE */ 
		/* 0xE8 */ 0x0438, /* CYRILLIC SMALL LETTER I */ 
		/* 0xE9 */ 0x0439, /* CYRILLIC SMALL LETTER SHORT I */ 
		/* 0xEA */ 0x043A, /* CYRILLIC SMALL LETTER KA */ 
		/* 0xEB */ 0x043B, /* CYRILLIC SMALL LETTER EL */ 
		/* 0xEC */ 0x043C, /* CYRILLIC SMALL LETTER EM */ 
		/* 0xED */ 0x043D, /* CYRILLIC SMALL LETTER EN */ 
		/* 0xEE */ 0x043E, /* CYRILLIC SMALL LETTER O */ 
		/* 0xEF */ 0x043F, /* CYRILLIC SMALL LETTER PE */ 
		/* 0xF0 */ 0x0440, /* CYRILLIC SMALL LETTER ER */ 
		/* 0xF1 */ 0x0441, /* CYRILLIC SMALL LETTER ES */ 
		/* 0xF2 */ 0x0442, /* CYRILLIC SMALL LETTER TE */ 
		/* 0xF3 */ 0x0443, /* CYRILLIC SMALL LETTER U */ 
		/* 0xF4 */ 0x0444, /* CYRILLIC SMALL LETTER EF */ 
		/* 0xF5 */ 0x0445, /* CYRILLIC SMALL LETTER HA */ 
		/* 0xF6 */ 0x0446, /* CYRILLIC SMALL LETTER TSE */ 
		/* 0xF7 */ 0x0447, /* CYRILLIC SMALL LETTER CHE */ 
		/* 0xF8 */ 0x0448, /* CYRILLIC SMALL LETTER SHA */ 
		/* 0xF9 */ 0x0449, /* CYRILLIC SMALL LETTER SHCHA */ 
		/* 0xFA */ 0x044A, /* CYRILLIC SMALL LETTER HARD SIGN */ 
		/* 0xFB */ 0x044B, /* CYRILLIC SMALL LETTER YERU */ 
		/* 0xFC */ 0x044C, /* CYRILLIC SMALL LETTER SOFT SIGN */ 
		/* 0xFD */ 0x044D, /* CYRILLIC SMALL LETTER E */ 
		/* 0xFE */ 0x044E, /* CYRILLIC SMALL LETTER YU */ 
		/* 0xFF */ 0x044F, /* CYRILLIC SMALL LETTER YA*/
	};

	private static char[] cp1252 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */ 0x02C6, /* MODIFIER LETTER CIRCUMFLEX ACCENT */ 
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */ 0x0160, /* LATIN CAPITAL LETTER S WITH CARON */ 
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */ 0x0152, /* LATIN CAPITAL LIGATURE OE */ 
		/* 0x8D */			0x20,
		/* 0x8E */ 0x017D, /* LATIN CAPITAL LETTER Z WITH CARON */ 
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */ 0x02DC, /* SMALL TILDE */ 
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */ 0x0161, /* LATIN SMALL LETTER S WITH CARON */ 
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */ 0x0153, /* LATIN SMALL LIGATURE OE */ 
		/* 0x9D */			0x20,
		/* 0x9E */ 0x017E, /* LATIN SMALL LETTER Z WITH CARON */ 
		/* 0x9F */ 0x0178, /* LATIN CAPITAL LETTER Y WITH DIAERESIS */ 
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xA2 */ 0x00A2, /* CENT SIGN */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x00A5, /* YEN SIGN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x00AA, /* FEMININE ORDINAL INDICATOR */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x00AF, /* MACRON */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00B8, /* CEDILLA */ 
		/* 0xB9 */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xBA */ 0x00BA, /* MASCULINE ORDINAL INDICATOR */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xBF */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xC0 */ 0x00C0, /* LATIN CAPITAL LETTER A WITH GRAVE */ 
		/* 0xC1 */ 0x00C1, /* LATIN CAPITAL LETTER A WITH ACUTE */ 
		/* 0xC2 */ 0x00C2, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */ 
		/* 0xC3 */ 0x00C3, /* LATIN CAPITAL LETTER A WITH TILDE */ 
		/* 0xC4 */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0xC5 */ 0x00C5, /* LATIN CAPITAL LETTER A WITH RING ABOVE */ 
		/* 0xC6 */ 0x00C6, /* LATIN CAPITAL LETTER AE */ 
		/* 0xC7 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0xC8 */ 0x00C8, /* LATIN CAPITAL LETTER E WITH GRAVE */ 
		/* 0xC9 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0xCA */ 0x00CA, /* LATIN CAPITAL LETTER E WITH CIRCUMFLEX */ 
		/* 0xCB */ 0x00CB, /* LATIN CAPITAL LETTER E WITH DIAERESIS */ 
		/* 0xCC */ 0x00CC, /* LATIN CAPITAL LETTER I WITH GRAVE */ 
		/* 0xCD */ 0x00CD, /* LATIN CAPITAL LETTER I WITH ACUTE */ 
		/* 0xCE */ 0x00CE, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */ 
		/* 0xCF */ 0x00CF, /* LATIN CAPITAL LETTER I WITH DIAERESIS */ 
		/* 0xD0 */ 0x00D0, /* LATIN CAPITAL LETTER ETH */ 
		/* 0xD1 */ 0x00D1, /* LATIN CAPITAL LETTER N WITH TILDE */ 
		/* 0xD2 */ 0x00D2, /* LATIN CAPITAL LETTER O WITH GRAVE */ 
		/* 0xD3 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xD4 */ 0x00D4, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */ 
		/* 0xD5 */ 0x00D5, /* LATIN CAPITAL LETTER O WITH TILDE */ 
		/* 0xD6 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0xD7 */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xD8 */ 0x00D8, /* LATIN CAPITAL LETTER O WITH STROKE */ 
		/* 0xD9 */ 0x00D9, /* LATIN CAPITAL LETTER U WITH GRAVE */ 
		/* 0xDA */ 0x00DA, /* LATIN CAPITAL LETTER U WITH ACUTE */ 
		/* 0xDB */ 0x00DB, /* LATIN CAPITAL LETTER U WITH CIRCUMFLEX */ 
		/* 0xDC */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0xDD */ 0x00DD, /* LATIN CAPITAL LETTER Y WITH ACUTE */ 
		/* 0xDE */ 0x00DE, /* LATIN CAPITAL LETTER THORN */ 
		/* 0xDF */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE0 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0xE1 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xE2 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x00E3, /* LATIN SMALL LETTER A WITH TILDE */ 
		/* 0xE4 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0xE5 */ 0x00E5, /* LATIN SMALL LETTER A WITH RING ABOVE */ 
		/* 0xE6 */ 0x00E6, /* LATIN SMALL LETTER AE */ 
		/* 0xE7 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0xE8 */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0xE9 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0xEA */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0xEB */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0xEC */ 0x00EC, /* LATIN SMALL LETTER I WITH GRAVE */ 
		/* 0xED */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xEE */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0xEF */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0xF0 */ 0x00F0, /* LATIN SMALL LETTER ETH */ 
		/* 0xF1 */ 0x00F1, /* LATIN SMALL LETTER N WITH TILDE */ 
		/* 0xF2 */ 0x00F2, /* LATIN SMALL LETTER O WITH GRAVE */ 
		/* 0xF3 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xF4 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0xF5 */ 0x00F5, /* LATIN SMALL LETTER O WITH TILDE */ 
		/* 0xF6 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0xF7 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF8 */ 0x00F8, /* LATIN SMALL LETTER O WITH STROKE */ 
		/* 0xF9 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0xFA */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xFB */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0xFC */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0xFD */ 0x00FD, /* LATIN SMALL LETTER Y WITH ACUTE */ 
		/* 0xFE */ 0x00FE, /* LATIN SMALL LETTER THORN */ 
		/* 0xFF */ 0x00FF, /* LATIN SMALL LETTER Y WITH DIAERESIS */
	};

	private static char[] cp1253 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */			0x20,
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */			0x20,
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */			0x20,
		/* 0x8D */			0x20,
		/* 0x8E */			0x20,
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */			0x20,
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */			0x20,
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */			0x20,
		/* 0x9D */			0x20,
		/* 0x9E */			0x20,
		/* 0x9F */			0x20,
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x0385, /* GREEK DIALYTIKA TONOS */ 
		/* 0xA2 */ 0x0386, /* GREEK CAPITAL LETTER ALPHA WITH TONOS */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x00A5, /* YEN SIGN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */			0x20,
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x2015, /* HORIZONTAL BAR */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x0384, /* GREEK TONOS */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x0388, /* GREEK CAPITAL LETTER EPSILON WITH TONOS */ 
		/* 0xB9 */ 0x0389, /* GREEK CAPITAL LETTER ETA WITH TONOS */ 
		/* 0xBA */ 0x038A, /* GREEK CAPITAL LETTER IOTA WITH TONOS */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x038C, /* GREEK CAPITAL LETTER OMICRON WITH TONOS */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x038E, /* GREEK CAPITAL LETTER UPSILON WITH TONOS */ 
		/* 0xBF */ 0x038F, /* GREEK CAPITAL LETTER OMEGA WITH TONOS */ 
		/* 0xC0 */ 0x0390, /* GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS */ 
		/* 0xC1 */ 0x0391, /* GREEK CAPITAL LETTER ALPHA */ 
		/* 0xC2 */ 0x0392, /* GREEK CAPITAL LETTER BETA */ 
		/* 0xC3 */ 0x0393, /* GREEK CAPITAL LETTER GAMMA */ 
		/* 0xC4 */ 0x0394, /* GREEK CAPITAL LETTER DELTA */ 
		/* 0xC5 */ 0x0395, /* GREEK CAPITAL LETTER EPSILON */ 
		/* 0xC6 */ 0x0396, /* GREEK CAPITAL LETTER ZETA */ 
		/* 0xC7 */ 0x0397, /* GREEK CAPITAL LETTER ETA */ 
		/* 0xC8 */ 0x0398, /* GREEK CAPITAL LETTER THETA */ 
		/* 0xC9 */ 0x0399, /* GREEK CAPITAL LETTER IOTA */ 
		/* 0xCA */ 0x039A, /* GREEK CAPITAL LETTER KAPPA */ 
		/* 0xCB */ 0x039B, /* GREEK CAPITAL LETTER LAMDA */ 
		/* 0xCC */ 0x039C, /* GREEK CAPITAL LETTER MU */ 
		/* 0xCD */ 0x039D, /* GREEK CAPITAL LETTER NU */ 
		/* 0xCE */ 0x039E, /* GREEK CAPITAL LETTER XI */ 
		/* 0xCF */ 0x039F, /* GREEK CAPITAL LETTER OMICRON */ 
		/* 0xD0 */ 0x03A0, /* GREEK CAPITAL LETTER PI */ 
		/* 0xD1 */ 0x03A1, /* GREEK CAPITAL LETTER RHO */ 
		/* 0xD2 */			0x20,
		/* 0xD3 */ 0x03A3, /* GREEK CAPITAL LETTER SIGMA */ 
		/* 0xD4 */ 0x03A4, /* GREEK CAPITAL LETTER TAU */ 
		/* 0xD5 */ 0x03A5, /* GREEK CAPITAL LETTER UPSILON */ 
		/* 0xD6 */ 0x03A6, /* GREEK CAPITAL LETTER PHI */ 
		/* 0xD7 */ 0x03A7, /* GREEK CAPITAL LETTER CHI */ 
		/* 0xD8 */ 0x03A8, /* GREEK CAPITAL LETTER PSI */ 
		/* 0xD9 */ 0x03A9, /* GREEK CAPITAL LETTER OMEGA */ 
		/* 0xDA */ 0x03AA, /* GREEK CAPITAL LETTER IOTA WITH DIALYTIKA */ 
		/* 0xDB */ 0x03AB, /* GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA */ 
		/* 0xDC */ 0x03AC, /* GREEK SMALL LETTER ALPHA WITH TONOS */ 
		/* 0xDD */ 0x03AD, /* GREEK SMALL LETTER EPSILON WITH TONOS */ 
		/* 0xDE */ 0x03AE, /* GREEK SMALL LETTER ETA WITH TONOS */ 
		/* 0xDF */ 0x03AF, /* GREEK SMALL LETTER IOTA WITH TONOS */ 
		/* 0xE0 */ 0x03B0, /* GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS */ 
		/* 0xE1 */ 0x03B1, /* GREEK SMALL LETTER ALPHA */ 
		/* 0xE2 */ 0x03B2, /* GREEK SMALL LETTER BETA */ 
		/* 0xE3 */ 0x03B3, /* GREEK SMALL LETTER GAMMA */ 
		/* 0xE4 */ 0x03B4, /* GREEK SMALL LETTER DELTA */ 
		/* 0xE5 */ 0x03B5, /* GREEK SMALL LETTER EPSILON */ 
		/* 0xE6 */ 0x03B6, /* GREEK SMALL LETTER ZETA */ 
		/* 0xE7 */ 0x03B7, /* GREEK SMALL LETTER ETA */ 
		/* 0xE8 */ 0x03B8, /* GREEK SMALL LETTER THETA */ 
		/* 0xE9 */ 0x03B9, /* GREEK SMALL LETTER IOTA */ 
		/* 0xEA */ 0x03BA, /* GREEK SMALL LETTER KAPPA */ 
		/* 0xEB */ 0x03BB, /* GREEK SMALL LETTER LAMDA */ 
		/* 0xEC */ 0x03BC, /* GREEK SMALL LETTER MU */ 
		/* 0xED */ 0x03BD, /* GREEK SMALL LETTER NU */ 
		/* 0xEE */ 0x03BE, /* GREEK SMALL LETTER XI */ 
		/* 0xEF */ 0x03BF, /* GREEK SMALL LETTER OMICRON */ 
		/* 0xF0 */ 0x03C0, /* GREEK SMALL LETTER PI */ 
		/* 0xF1 */ 0x03C1, /* GREEK SMALL LETTER RHO */ 
		/* 0xF2 */ 0x03C2, /* GREEK SMALL LETTER FINAL SIGMA */ 
		/* 0xF3 */ 0x03C3, /* GREEK SMALL LETTER SIGMA */ 
		/* 0xF4 */ 0x03C4, /* GREEK SMALL LETTER TAU */ 
		/* 0xF5 */ 0x03C5, /* GREEK SMALL LETTER UPSILON */ 
		/* 0xF6 */ 0x03C6, /* GREEK SMALL LETTER PHI */ 
		/* 0xF7 */ 0x03C7, /* GREEK SMALL LETTER CHI */ 
		/* 0xF8 */ 0x03C8, /* GREEK SMALL LETTER PSI */ 
		/* 0xF9 */ 0x03C9, /* GREEK SMALL LETTER OMEGA */ 
		/* 0xFA */ 0x03CA, /* GREEK SMALL LETTER IOTA WITH DIALYTIKA */ 
		/* 0xFB */ 0x03CB, /* GREEK SMALL LETTER UPSILON WITH DIALYTIKA */ 
		/* 0xFC */ 0x03CC, /* GREEK SMALL LETTER OMICRON WITH TONOS */ 
		/* 0xFD */ 0x03CD, /* GREEK SMALL LETTER UPSILON WITH TONOS */ 
		/* 0xFE */ 0x03CE, /* GREEK SMALL LETTER OMEGA WITH TONOS  */ 
		/* 0xFF */			0x20,
	};

	private static char[] cp1254 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */ 0x02C6, /* MODIFIER LETTER CIRCUMFLEX ACCENT */ 
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */ 0x0160, /* LATIN CAPITAL LETTER S WITH CARON */ 
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */ 0x0152, /* LATIN CAPITAL LIGATURE OE */ 
		/* 0x8D */			0x20,
		/* 0x8E */			0x20,
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */ 0x02DC, /* SMALL TILDE */ 
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */ 0x0161, /* LATIN SMALL LETTER S WITH CARON */ 
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */ 0x0153, /* LATIN SMALL LIGATURE OE */ 
		/* 0x9D */			0x20,
		/* 0x9E */			0x20,
		/* 0x9F */ 0x0178, /* LATIN CAPITAL LETTER Y WITH DIAERESIS */ 
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xA2 */ 0x00A2, /* CENT SIGN */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x00A5, /* YEN SIGN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x00AA, /* FEMININE ORDINAL INDICATOR */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x00AF, /* MACRON */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00B8, /* CEDILLA */ 
		/* 0xB9 */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xBA */ 0x00BA, /* MASCULINE ORDINAL INDICATOR */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xBF */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xC0 */ 0x00C0, /* LATIN CAPITAL LETTER A WITH GRAVE */ 
		/* 0xC1 */ 0x00C1, /* LATIN CAPITAL LETTER A WITH ACUTE */ 
		/* 0xC2 */ 0x00C2, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */ 
		/* 0xC3 */ 0x00C3, /* LATIN CAPITAL LETTER A WITH TILDE */ 
		/* 0xC4 */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0xC5 */ 0x00C5, /* LATIN CAPITAL LETTER A WITH RING ABOVE */ 
		/* 0xC6 */ 0x00C6, /* LATIN CAPITAL LETTER AE */ 
		/* 0xC7 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0xC8 */ 0x00C8, /* LATIN CAPITAL LETTER E WITH GRAVE */ 
		/* 0xC9 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0xCA */ 0x00CA, /* LATIN CAPITAL LETTER E WITH CIRCUMFLEX */ 
		/* 0xCB */ 0x00CB, /* LATIN CAPITAL LETTER E WITH DIAERESIS */ 
		/* 0xCC */ 0x00CC, /* LATIN CAPITAL LETTER I WITH GRAVE */ 
		/* 0xCD */ 0x00CD, /* LATIN CAPITAL LETTER I WITH ACUTE */ 
		/* 0xCE */ 0x00CE, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */ 
		/* 0xCF */ 0x00CF, /* LATIN CAPITAL LETTER I WITH DIAERESIS */ 
		/* 0xD0 */ 0x011E, /* LATIN CAPITAL LETTER G WITH BREVE */ 
		/* 0xD1 */ 0x00D1, /* LATIN CAPITAL LETTER N WITH TILDE */ 
		/* 0xD2 */ 0x00D2, /* LATIN CAPITAL LETTER O WITH GRAVE */ 
		/* 0xD3 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xD4 */ 0x00D4, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */ 
		/* 0xD5 */ 0x00D5, /* LATIN CAPITAL LETTER O WITH TILDE */ 
		/* 0xD6 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0xD7 */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xD8 */ 0x00D8, /* LATIN CAPITAL LETTER O WITH STROKE */ 
		/* 0xD9 */ 0x00D9, /* LATIN CAPITAL LETTER U WITH GRAVE */ 
		/* 0xDA */ 0x00DA, /* LATIN CAPITAL LETTER U WITH ACUTE */ 
		/* 0xDB */ 0x00DB, /* LATIN CAPITAL LETTER U WITH CIRCUMFLEX */ 
		/* 0xDC */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0xDD */ 0x0130, /* LATIN CAPITAL LETTER I WITH DOT ABOVE */ 
		/* 0xDE */ 0x015E, /* LATIN CAPITAL LETTER S WITH CEDILLA */ 
		/* 0xDF */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE0 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0xE1 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xE2 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x00E3, /* LATIN SMALL LETTER A WITH TILDE */ 
		/* 0xE4 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0xE5 */ 0x00E5, /* LATIN SMALL LETTER A WITH RING ABOVE */ 
		/* 0xE6 */ 0x00E6, /* LATIN SMALL LETTER AE */ 
		/* 0xE7 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0xE8 */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0xE9 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0xEA */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0xEB */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0xEC */ 0x00EC, /* LATIN SMALL LETTER I WITH GRAVE */ 
		/* 0xED */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xEE */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0xEF */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0xF0 */ 0x011F, /* LATIN SMALL LETTER G WITH BREVE */ 
		/* 0xF1 */ 0x00F1, /* LATIN SMALL LETTER N WITH TILDE */ 
		/* 0xF2 */ 0x00F2, /* LATIN SMALL LETTER O WITH GRAVE */ 
		/* 0xF3 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xF4 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0xF5 */ 0x00F5, /* LATIN SMALL LETTER O WITH TILDE */ 
		/* 0xF6 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0xF7 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF8 */ 0x00F8, /* LATIN SMALL LETTER O WITH STROKE */ 
		/* 0xF9 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0xFA */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xFB */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0xFC */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0xFD */ 0x0131, /* LATIN SMALL LETTER DOTLESS I */ 
		/* 0xFE */ 0x015F, /* LATIN SMALL LETTER S WITH CEDILLA */ 
		/* 0xFF */ 0x00FF, /* LATIN SMALL LETTER Y WITH DIAERESIS  */ 
	};

	private static char[] cp1255 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */ 0x02C6, /* MODIFIER LETTER CIRCUMFLEX ACCENT */ 
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */			0x20,
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */			0x20,
		/* 0x8D */			0x20,
		/* 0x8E */			0x20,
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */ 0x02DC, /* SMALL TILDE */ 
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */			0x20,
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */			0x20,
		/* 0x9D */			0x20,
		/* 0x9E */			0x20,
		/* 0x9F */			0x20,
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xA2 */ 0x00A2, /* CENT SIGN */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x20AA, /* NEW SHEQEL SIGN */ 
		/* 0xA5 */ 0x00A5, /* YEN SIGN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x00AF, /* MACRON */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00B8, /* CEDILLA */ 
		/* 0xB9 */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xBA */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xBF */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xC0 */ 0x05B0, /* HEBREW POINT SHEVA */ 
		/* 0xC1 */ 0x05B1, /* HEBREW POINT HATAF SEGOL */ 
		/* 0xC2 */ 0x05B2, /* HEBREW POINT HATAF PATAH */ 
		/* 0xC3 */ 0x05B3, /* HEBREW POINT HATAF QAMATS */ 
		/* 0xC4 */ 0x05B4, /* HEBREW POINT HIRIQ */ 
		/* 0xC5 */ 0x05B5, /* HEBREW POINT TSERE */ 
		/* 0xC6 */ 0x05B6, /* HEBREW POINT SEGOL */ 
		/* 0xC7 */ 0x05B7, /* HEBREW POINT PATAH */ 
		/* 0xC8 */ 0x05B8, /* HEBREW POINT QAMATS */ 
		/* 0xC9 */ 0x05B9, /* HEBREW POINT HOLAM */ 
		/* 0xCA */			0x20,
		/* 0xCB */ 0x05BB, /* HEBREW POINT QUBUTS */ 
		/* 0xCC */ 0x05BC, /* HEBREW POINT DAGESH OR MAPIQ */ 
		/* 0xCD */ 0x05BD, /* HEBREW POINT METEG */ 
		/* 0xCE */ 0x05BE, /* HEBREW PUNCTUATION MAQAF */ 
		/* 0xCF */ 0x05BF, /* HEBREW POINT RAFE */ 
		/* 0xD0 */ 0x05C0, /* HEBREW PUNCTUATION PASEQ */ 
		/* 0xD1 */ 0x05C1, /* HEBREW POINT SHIN DOT */ 
		/* 0xD2 */ 0x05C2, /* HEBREW POINT SIN DOT */ 
		/* 0xD3 */ 0x05C3, /* HEBREW PUNCTUATION SOF PASUQ */ 
		/* 0xD4 */ 0x05F0, /* HEBREW LIGATURE YIDDISH DOUBLE VAV */ 
		/* 0xD5 */ 0x05F1, /* HEBREW LIGATURE YIDDISH VAV YOD */ 
		/* 0xD6 */ 0x05F2, /* HEBREW LIGATURE YIDDISH DOUBLE YOD */ 
		/* 0xD7 */ 0x05F3, /* HEBREW PUNCTUATION GERESH */ 
		/* 0xD8 */ 0x05F4, /* HEBREW PUNCTUATION GERSHAYIM */ 
		/* 0xD9 */			0x20,
		/* 0xDA */			0x20,
		/* 0xDB */			0x20,
		/* 0xDC */			0x20,
		/* 0xDD */			0x20,
		/* 0xDE */			0x20,
		/* 0xDF */			0x20,
		/* 0xE0 */ 0x05D0, /* HEBREW LETTER ALEF */ 
		/* 0xE1 */ 0x05D1, /* HEBREW LETTER BET */ 
		/* 0xE2 */ 0x05D2, /* HEBREW LETTER GIMEL */ 
		/* 0xE3 */ 0x05D3, /* HEBREW LETTER DALET */ 
		/* 0xE4 */ 0x05D4, /* HEBREW LETTER HE */ 
		/* 0xE5 */ 0x05D5, /* HEBREW LETTER VAV */ 
		/* 0xE6 */ 0x05D6, /* HEBREW LETTER ZAYIN */ 
		/* 0xE7 */ 0x05D7, /* HEBREW LETTER HET */ 
		/* 0xE8 */ 0x05D8, /* HEBREW LETTER TET */ 
		/* 0xE9 */ 0x05D9, /* HEBREW LETTER YOD */ 
		/* 0xEA */ 0x05DA, /* HEBREW LETTER FINAL KAF */ 
		/* 0xEB */ 0x05DB, /* HEBREW LETTER KAF */ 
		/* 0xEC */ 0x05DC, /* HEBREW LETTER LAMED */ 
		/* 0xED */ 0x05DD, /* HEBREW LETTER FINAL MEM */ 
		/* 0xEE */ 0x05DE, /* HEBREW LETTER MEM */ 
		/* 0xEF */ 0x05DF, /* HEBREW LETTER FINAL NUN */ 
		/* 0xF0 */ 0x05E0, /* HEBREW LETTER NUN */ 
		/* 0xF1 */ 0x05E1, /* HEBREW LETTER SAMEKH */ 
		/* 0xF2 */ 0x05E2, /* HEBREW LETTER AYIN */ 
		/* 0xF3 */ 0x05E3, /* HEBREW LETTER FINAL PE */ 
		/* 0xF4 */ 0x05E4, /* HEBREW LETTER PE */ 
		/* 0xF5 */ 0x05E5, /* HEBREW LETTER FINAL TSADI */ 
		/* 0xF6 */ 0x05E6, /* HEBREW LETTER TSADI */ 
		/* 0xF7 */ 0x05E7, /* HEBREW LETTER QOF */ 
		/* 0xF8 */ 0x05E8, /* HEBREW LETTER RESH */ 
		/* 0xF9 */ 0x05E9, /* HEBREW LETTER SHIN */ 
		/* 0xFA */ 0x05EA, /* HEBREW LETTER TAV */ 
		/* 0xFB */			0x20,
		/* 0xFC */			0x20,
		/* 0xFD */ 0x200E, /* LEFT-TO-RIGHT MARK */ 
		/* 0xFE */ 0x200F, /* RIGHT-TO-LEFT MARK  */ 
		/* 0xFF */			0x20,
	};

	private static char[] cp1256 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */ 0x067E, /* ARABIC LETTER PEH */ 
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */ 0x02C6, /* MODIFIER LETTER CIRCUMFLEX ACCENT */ 
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */ 0x0679, /* ARABIC LETTER TTEH */ 
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */ 0x0152, /* LATIN CAPITAL LIGATURE OE */ 
		/* 0x8D */ 0x0686, /* ARABIC LETTER TCHEH */ 
		/* 0x8E */ 0x0698, /* ARABIC LETTER JEH */ 
		/* 0x8F */ 0x0688, /* ARABIC LETTER DDAL */ 
		/* 0x90 */ 0x06AF, /* ARABIC LETTER GAF */ 
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */ 0x06A9, /* ARABIC LETTER KEHEH */ 
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */ 0x0691, /* ARABIC LETTER RREH */ 
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */ 0x0153, /* LATIN SMALL LIGATURE OE */ 
		/* 0x9D */ 0x200C, /* ZERO WIDTH NON-JOINER */ 
		/* 0x9E */ 0x200D, /* ZERO WIDTH JOINER */ 
		/* 0x9F */ 0x06BA, /* ARABIC LETTER NOON GHUNNA */ 
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x060C, /* ARABIC COMMA */ 
		/* 0xA2 */ 0x00A2, /* CENT SIGN */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x00A5, /* YEN SIGN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x06BE, /* ARABIC LETTER HEH DOACHASHMEE */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x00AF, /* MACRON */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00B8, /* CEDILLA */ 
		/* 0xB9 */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xBA */ 0x061B, /* ARABIC SEMICOLON */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xBF */ 0x061F, /* ARABIC QUESTION MARK */ 
		/* 0xC0 */ 0x06C1, /* ARABIC LETTER HEH GOAL */ 
		/* 0xC1 */ 0x0621, /* ARABIC LETTER HAMZA */ 
		/* 0xC2 */ 0x0622, /* ARABIC LETTER ALEF WITH MADDA ABOVE */ 
		/* 0xC3 */ 0x0623, /* ARABIC LETTER ALEF WITH HAMZA ABOVE */ 
		/* 0xC4 */ 0x0624, /* ARABIC LETTER WAW WITH HAMZA ABOVE */ 
		/* 0xC5 */ 0x0625, /* ARABIC LETTER ALEF WITH HAMZA BELOW */ 
		/* 0xC6 */ 0x0626, /* ARABIC LETTER YEH WITH HAMZA ABOVE */ 
		/* 0xC7 */ 0x0627, /* ARABIC LETTER ALEF */ 
		/* 0xC8 */ 0x0628, /* ARABIC LETTER BEH */ 
		/* 0xC9 */ 0x0629, /* ARABIC LETTER TEH MARBUTA */ 
		/* 0xCA */ 0x062A, /* ARABIC LETTER TEH */ 
		/* 0xCB */ 0x062B, /* ARABIC LETTER THEH */ 
		/* 0xCC */ 0x062C, /* ARABIC LETTER JEEM */ 
		/* 0xCD */ 0x062D, /* ARABIC LETTER HAH */ 
		/* 0xCE */ 0x062E, /* ARABIC LETTER KHAH */ 
		/* 0xCF */ 0x062F, /* ARABIC LETTER DAL */ 
		/* 0xD0 */ 0x0630, /* ARABIC LETTER THAL */ 
		/* 0xD1 */ 0x0631, /* ARABIC LETTER REH */ 
		/* 0xD2 */ 0x0632, /* ARABIC LETTER ZAIN */ 
		/* 0xD3 */ 0x0633, /* ARABIC LETTER SEEN */ 
		/* 0xD4 */ 0x0634, /* ARABIC LETTER SHEEN */ 
		/* 0xD5 */ 0x0635, /* ARABIC LETTER SAD */ 
		/* 0xD6 */ 0x0636, /* ARABIC LETTER DAD */ 
		/* 0xD7 */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xD8 */ 0x0637, /* ARABIC LETTER TAH */ 
		/* 0xD9 */ 0x0638, /* ARABIC LETTER ZAH */ 
		/* 0xDA */ 0x0639, /* ARABIC LETTER AIN */ 
		/* 0xDB */ 0x063A, /* ARABIC LETTER GHAIN */ 
		/* 0xDC */ 0x0640, /* ARABIC TATWEEL */ 
		/* 0xDD */ 0x0641, /* ARABIC LETTER FEH */ 
		/* 0xDE */ 0x0642, /* ARABIC LETTER QAF */ 
		/* 0xDF */ 0x0643, /* ARABIC LETTER KAF */ 
		/* 0xE0 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0xE1 */ 0x0644, /* ARABIC LETTER LAM */ 
		/* 0xE2 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x0645, /* ARABIC LETTER MEEM */ 
		/* 0xE4 */ 0x0646, /* ARABIC LETTER NOON */ 
		/* 0xE5 */ 0x0647, /* ARABIC LETTER HEH */ 
		/* 0xE6 */ 0x0648, /* ARABIC LETTER WAW */ 
		/* 0xE7 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0xE8 */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0xE9 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0xEA */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0xEB */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0xEC */ 0x0649, /* ARABIC LETTER ALEF MAKSURA */ 
		/* 0xED */ 0x064A, /* ARABIC LETTER YEH */ 
		/* 0xEE */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0xEF */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0xF0 */ 0x064B, /* ARABIC FATHATAN */ 
		/* 0xF1 */ 0x064C, /* ARABIC DAMMATAN */ 
		/* 0xF2 */ 0x064D, /* ARABIC KASRATAN */ 
		/* 0xF3 */ 0x064E, /* ARABIC FATHA */ 
		/* 0xF4 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0xF5 */ 0x064F, /* ARABIC DAMMA */ 
		/* 0xF6 */ 0x0650, /* ARABIC KASRA */ 
		/* 0xF7 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF8 */ 0x0651, /* ARABIC SHADDA */ 
		/* 0xF9 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0xFA */ 0x0652, /* ARABIC SUKUN */ 
		/* 0xFB */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0xFC */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0xFD */ 0x200E, /* LEFT-TO-RIGHT MARK */ 
		/* 0xFE */ 0x200F, /* RIGHT-TO-LEFT MARK */ 
		/* 0xFF */ 0x06D2, /* ARABIC LETTER YEH BARREE  */ 
	};

	private static char[] cp1257 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */			0x20,
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */			0x20,
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */			0x20,
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */			0x20,
		/* 0x8D */ 0x00A8, /* DIAERESIS */ 
		/* 0x8E */ 0x02C7, /* CARON */ 
		/* 0x8F */ 0x00B8, /* CEDILLA */ 
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */			0x20,
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */			0x20,
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */			0x20,
		/* 0x9D */ 0x00AF, /* MACRON */ 
		/* 0x9E */ 0x02DB, /* OGONEK */ 
		/* 0x9F */			0x20,
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */			0x20,
		/* 0xA2 */ 0x00A2, /* CENT SIGN */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */			0x20,
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00D8, /* LATIN CAPITAL LETTER O WITH STROKE */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x0156, /* LATIN CAPITAL LETTER R WITH CEDILLA */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x00C6, /* LATIN CAPITAL LETTER AE */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00F8, /* LATIN SMALL LETTER O WITH STROKE */ 
		/* 0xB9 */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xBA */ 0x0157, /* LATIN SMALL LETTER R WITH CEDILLA */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xBF */ 0x00E6, /* LATIN SMALL LETTER AE */ 
		/* 0xC0 */ 0x0104, /* LATIN CAPITAL LETTER A WITH OGONEK */ 
		/* 0xC1 */ 0x012E, /* LATIN CAPITAL LETTER I WITH OGONEK */ 
		/* 0xC2 */ 0x0100, /* LATIN CAPITAL LETTER A WITH MACRON */ 
		/* 0xC3 */ 0x0106, /* LATIN CAPITAL LETTER C WITH ACUTE */ 
		/* 0xC4 */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0xC5 */ 0x00C5, /* LATIN CAPITAL LETTER A WITH RING ABOVE */ 
		/* 0xC6 */ 0x0118, /* LATIN CAPITAL LETTER E WITH OGONEK */ 
		/* 0xC7 */ 0x0112, /* LATIN CAPITAL LETTER E WITH MACRON */ 
		/* 0xC8 */ 0x010C, /* LATIN CAPITAL LETTER C WITH CARON */ 
		/* 0xC9 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0xCA */ 0x0179, /* LATIN CAPITAL LETTER Z WITH ACUTE */ 
		/* 0xCB */ 0x0116, /* LATIN CAPITAL LETTER E WITH DOT ABOVE */ 
		/* 0xCC */ 0x0122, /* LATIN CAPITAL LETTER G WITH CEDILLA */ 
		/* 0xCD */ 0x0136, /* LATIN CAPITAL LETTER K WITH CEDILLA */ 
		/* 0xCE */ 0x012A, /* LATIN CAPITAL LETTER I WITH MACRON */ 
		/* 0xCF */ 0x013B, /* LATIN CAPITAL LETTER L WITH CEDILLA */ 
		/* 0xD0 */ 0x0160, /* LATIN CAPITAL LETTER S WITH CARON */ 
		/* 0xD1 */ 0x0143, /* LATIN CAPITAL LETTER N WITH ACUTE */ 
		/* 0xD2 */ 0x0145, /* LATIN CAPITAL LETTER N WITH CEDILLA */ 
		/* 0xD3 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xD4 */ 0x014C, /* LATIN CAPITAL LETTER O WITH MACRON */ 
		/* 0xD5 */ 0x00D5, /* LATIN CAPITAL LETTER O WITH TILDE */ 
		/* 0xD6 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0xD7 */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xD8 */ 0x0172, /* LATIN CAPITAL LETTER U WITH OGONEK */ 
		/* 0xD9 */ 0x0141, /* LATIN CAPITAL LETTER L WITH STROKE */ 
		/* 0xDA */ 0x015A, /* LATIN CAPITAL LETTER S WITH ACUTE */ 
		/* 0xDB */ 0x016A, /* LATIN CAPITAL LETTER U WITH MACRON */ 
		/* 0xDC */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0xDD */ 0x017B, /* LATIN CAPITAL LETTER Z WITH DOT ABOVE */ 
		/* 0xDE */ 0x017D, /* LATIN CAPITAL LETTER Z WITH CARON */ 
		/* 0xDF */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE0 */ 0x0105, /* LATIN SMALL LETTER A WITH OGONEK */ 
		/* 0xE1 */ 0x012F, /* LATIN SMALL LETTER I WITH OGONEK */ 
		/* 0xE2 */ 0x0101, /* LATIN SMALL LETTER A WITH MACRON */ 
		/* 0xE3 */ 0x0107, /* LATIN SMALL LETTER C WITH ACUTE */ 
		/* 0xE4 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0xE5 */ 0x00E5, /* LATIN SMALL LETTER A WITH RING ABOVE */ 
		/* 0xE6 */ 0x0119, /* LATIN SMALL LETTER E WITH OGONEK */ 
		/* 0xE7 */ 0x0113, /* LATIN SMALL LETTER E WITH MACRON */ 
		/* 0xE8 */ 0x010D, /* LATIN SMALL LETTER C WITH CARON */ 
		/* 0xE9 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0xEA */ 0x017A, /* LATIN SMALL LETTER Z WITH ACUTE */ 
		/* 0xEB */ 0x0117, /* LATIN SMALL LETTER E WITH DOT ABOVE */ 
		/* 0xEC */ 0x0123, /* LATIN SMALL LETTER G WITH CEDILLA */ 
		/* 0xED */ 0x0137, /* LATIN SMALL LETTER K WITH CEDILLA */ 
		/* 0xEE */ 0x012B, /* LATIN SMALL LETTER I WITH MACRON */ 
		/* 0xEF */ 0x013C, /* LATIN SMALL LETTER L WITH CEDILLA */ 
		/* 0xF0 */ 0x0161, /* LATIN SMALL LETTER S WITH CARON */ 
		/* 0xF1 */ 0x0144, /* LATIN SMALL LETTER N WITH ACUTE */ 
		/* 0xF2 */ 0x0146, /* LATIN SMALL LETTER N WITH CEDILLA */ 
		/* 0xF3 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xF4 */ 0x014D, /* LATIN SMALL LETTER O WITH MACRON */ 
		/* 0xF5 */ 0x00F5, /* LATIN SMALL LETTER O WITH TILDE */ 
		/* 0xF6 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0xF7 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF8 */ 0x0173, /* LATIN SMALL LETTER U WITH OGONEK */ 
		/* 0xF9 */ 0x0142, /* LATIN SMALL LETTER L WITH STROKE */ 
		/* 0xFA */ 0x015B, /* LATIN SMALL LETTER S WITH ACUTE */ 
		/* 0xFB */ 0x016B, /* LATIN SMALL LETTER U WITH MACRON */ 
		/* 0xFC */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0xFD */ 0x017C, /* LATIN SMALL LETTER Z WITH DOT ABOVE */ 
		/* 0xFE */ 0x017E, /* LATIN SMALL LETTER Z WITH CARON */ 
		/* 0xFF */ 0x02D9, /* DOT ABOVE  */ 
	};

	private static char[] cp1258 = {
		/* 0x80 */ 0x20AC, /* EURO SIGN */ 
		/* 0x81 */			0x20,
		/* 0x82 */ 0x201A, /* SINGLE LOW-9 QUOTATION MARK */ 
		/* 0x83 */ 0x0192, /* LATIN SMALL LETTER F WITH HOOK */ 
		/* 0x84 */ 0x201E, /* DOUBLE LOW-9 QUOTATION MARK */ 
		/* 0x85 */ 0x2026, /* HORIZONTAL ELLIPSIS */ 
		/* 0x86 */ 0x2020, /* DAGGER */ 
		/* 0x87 */ 0x2021, /* DOUBLE DAGGER */ 
		/* 0x88 */ 0x02C6, /* MODIFIER LETTER CIRCUMFLEX ACCENT */ 
		/* 0x89 */ 0x2030, /* PER MILLE SIGN */ 
		/* 0x8A */			0x20,
		/* 0x8B */ 0x2039, /* SINGLE LEFT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x8C */ 0x0152, /* LATIN CAPITAL LIGATURE OE */ 
		/* 0x8D */			0x20,
		/* 0x8E */			0x20,
		/* 0x8F */			0x20,
		/* 0x90 */			0x20,
		/* 0x91 */ 0x2018, /* LEFT SINGLE QUOTATION MARK */ 
		/* 0x92 */ 0x2019, /* RIGHT SINGLE QUOTATION MARK */ 
		/* 0x93 */ 0x201C, /* LEFT DOUBLE QUOTATION MARK */ 
		/* 0x94 */ 0x201D, /* RIGHT DOUBLE QUOTATION MARK */ 
		/* 0x95 */ 0x2022, /* BULLET */ 
		/* 0x96 */ 0x2013, /* EN DASH */ 
		/* 0x97 */ 0x2014, /* EM DASH */ 
		/* 0x98 */ 0x02DC, /* SMALL TILDE */ 
		/* 0x99 */ 0x2122, /* TRADE MARK SIGN */ 
		/* 0x9A */			0x20,
		/* 0x9B */ 0x203A, /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */ 
		/* 0x9C */ 0x0153, /* LATIN SMALL LIGATURE OE */ 
		/* 0x9D */			0x20,
		/* 0x9E */			0x20,
		/* 0x9F */ 0x0178, /* LATIN CAPITAL LETTER Y WITH DIAERESIS */ 
		/* 0xA0 */ 0x00A0, /* NO-BREAK SPACE */ 
		/* 0xA1 */ 0x00A1, /* INVERTED EXCLAMATION MARK */ 
		/* 0xA2 */ 0x00A2, /* CENT SIGN */ 
		/* 0xA3 */ 0x00A3, /* POUND SIGN */ 
		/* 0xA4 */ 0x00A4, /* CURRENCY SIGN */ 
		/* 0xA5 */ 0x00A5, /* YEN SIGN */ 
		/* 0xA6 */ 0x00A6, /* BROKEN BAR */ 
		/* 0xA7 */ 0x00A7, /* SECTION SIGN */ 
		/* 0xA8 */ 0x00A8, /* DIAERESIS */ 
		/* 0xA9 */ 0x00A9, /* COPYRIGHT SIGN */ 
		/* 0xAA */ 0x00AA, /* FEMININE ORDINAL INDICATOR */ 
		/* 0xAB */ 0x00AB, /* LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xAC */ 0x00AC, /* NOT SIGN */ 
		/* 0xAD */ 0x00AD, /* SOFT HYPHEN */ 
		/* 0xAE */ 0x00AE, /* REGISTERED SIGN */ 
		/* 0xAF */ 0x00AF, /* MACRON */ 
		/* 0xB0 */ 0x00B0, /* DEGREE SIGN */ 
		/* 0xB1 */ 0x00B1, /* PLUS-MINUS SIGN */ 
		/* 0xB2 */ 0x00B2, /* SUPERSCRIPT TWO */ 
		/* 0xB3 */ 0x00B3, /* SUPERSCRIPT THREE */ 
		/* 0xB4 */ 0x00B4, /* ACUTE ACCENT */ 
		/* 0xB5 */ 0x00B5, /* MICRO SIGN */ 
		/* 0xB6 */ 0x00B6, /* PILCROW SIGN */ 
		/* 0xB7 */ 0x00B7, /* MIDDLE DOT */ 
		/* 0xB8 */ 0x00B8, /* CEDILLA */ 
		/* 0xB9 */ 0x00B9, /* SUPERSCRIPT ONE */ 
		/* 0xBA */ 0x00BA, /* MASCULINE ORDINAL INDICATOR */ 
		/* 0xBB */ 0x00BB, /* RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */ 
		/* 0xBC */ 0x00BC, /* VULGAR FRACTION ONE QUARTER */ 
		/* 0xBD */ 0x00BD, /* VULGAR FRACTION ONE HALF */ 
		/* 0xBE */ 0x00BE, /* VULGAR FRACTION THREE QUARTERS */ 
		/* 0xBF */ 0x00BF, /* INVERTED QUESTION MARK */ 
		/* 0xC0 */ 0x00C0, /* LATIN CAPITAL LETTER A WITH GRAVE */ 
		/* 0xC1 */ 0x00C1, /* LATIN CAPITAL LETTER A WITH ACUTE */ 
		/* 0xC2 */ 0x00C2, /* LATIN CAPITAL LETTER A WITH CIRCUMFLEX */ 
		/* 0xC3 */ 0x0102, /* LATIN CAPITAL LETTER A WITH BREVE */ 
		/* 0xC4 */ 0x00C4, /* LATIN CAPITAL LETTER A WITH DIAERESIS */ 
		/* 0xC5 */ 0x00C5, /* LATIN CAPITAL LETTER A WITH RING ABOVE */ 
		/* 0xC6 */ 0x00C6, /* LATIN CAPITAL LETTER AE */ 
		/* 0xC7 */ 0x00C7, /* LATIN CAPITAL LETTER C WITH CEDILLA */ 
		/* 0xC8 */ 0x00C8, /* LATIN CAPITAL LETTER E WITH GRAVE */ 
		/* 0xC9 */ 0x00C9, /* LATIN CAPITAL LETTER E WITH ACUTE */ 
		/* 0xCA */ 0x00CA, /* LATIN CAPITAL LETTER E WITH CIRCUMFLEX */ 
		/* 0xCB */ 0x00CB, /* LATIN CAPITAL LETTER E WITH DIAERESIS */ 
		/* 0xCC */ 0x0300, /* COMBINING GRAVE ACCENT */ 
		/* 0xCD */ 0x00CD, /* LATIN CAPITAL LETTER I WITH ACUTE */ 
		/* 0xCE */ 0x00CE, /* LATIN CAPITAL LETTER I WITH CIRCUMFLEX */ 
		/* 0xCF */ 0x00CF, /* LATIN CAPITAL LETTER I WITH DIAERESIS */ 
		/* 0xD0 */ 0x0110, /* LATIN CAPITAL LETTER D WITH STROKE */ 
		/* 0xD1 */ 0x00D1, /* LATIN CAPITAL LETTER N WITH TILDE */ 
		/* 0xD2 */ 0x0309, /* COMBINING HOOK ABOVE */ 
		/* 0xD3 */ 0x00D3, /* LATIN CAPITAL LETTER O WITH ACUTE */ 
		/* 0xD4 */ 0x00D4, /* LATIN CAPITAL LETTER O WITH CIRCUMFLEX */ 
		/* 0xD5 */ 0x01A0, /* LATIN CAPITAL LETTER O WITH HORN */ 
		/* 0xD6 */ 0x00D6, /* LATIN CAPITAL LETTER O WITH DIAERESIS */ 
		/* 0xD7 */ 0x00D7, /* MULTIPLICATION SIGN */ 
		/* 0xD8 */ 0x00D8, /* LATIN CAPITAL LETTER O WITH STROKE */ 
		/* 0xD9 */ 0x00D9, /* LATIN CAPITAL LETTER U WITH GRAVE */ 
		/* 0xDA */ 0x00DA, /* LATIN CAPITAL LETTER U WITH ACUTE */ 
		/* 0xDB */ 0x00DB, /* LATIN CAPITAL LETTER U WITH CIRCUMFLEX */ 
		/* 0xDC */ 0x00DC, /* LATIN CAPITAL LETTER U WITH DIAERESIS */ 
		/* 0xDD */ 0x01AF, /* LATIN CAPITAL LETTER U WITH HORN */ 
		/* 0xDE */ 0x0303, /* COMBINING TILDE */ 
		/* 0xDF */ 0x00DF, /* LATIN SMALL LETTER SHARP S */ 
		/* 0xE0 */ 0x00E0, /* LATIN SMALL LETTER A WITH GRAVE */ 
		/* 0xE1 */ 0x00E1, /* LATIN SMALL LETTER A WITH ACUTE */ 
		/* 0xE2 */ 0x00E2, /* LATIN SMALL LETTER A WITH CIRCUMFLEX */ 
		/* 0xE3 */ 0x0103, /* LATIN SMALL LETTER A WITH BREVE */ 
		/* 0xE4 */ 0x00E4, /* LATIN SMALL LETTER A WITH DIAERESIS */ 
		/* 0xE5 */ 0x00E5, /* LATIN SMALL LETTER A WITH RING ABOVE */ 
		/* 0xE6 */ 0x00E6, /* LATIN SMALL LETTER AE */ 
		/* 0xE7 */ 0x00E7, /* LATIN SMALL LETTER C WITH CEDILLA */ 
		/* 0xE8 */ 0x00E8, /* LATIN SMALL LETTER E WITH GRAVE */ 
		/* 0xE9 */ 0x00E9, /* LATIN SMALL LETTER E WITH ACUTE */ 
		/* 0xEA */ 0x00EA, /* LATIN SMALL LETTER E WITH CIRCUMFLEX */ 
		/* 0xEB */ 0x00EB, /* LATIN SMALL LETTER E WITH DIAERESIS */ 
		/* 0xEC */ 0x0301, /* COMBINING ACUTE ACCENT */ 
		/* 0xED */ 0x00ED, /* LATIN SMALL LETTER I WITH ACUTE */ 
		/* 0xEE */ 0x00EE, /* LATIN SMALL LETTER I WITH CIRCUMFLEX */ 
		/* 0xEF */ 0x00EF, /* LATIN SMALL LETTER I WITH DIAERESIS */ 
		/* 0xF0 */ 0x0111, /* LATIN SMALL LETTER D WITH STROKE */ 
		/* 0xF1 */ 0x00F1, /* LATIN SMALL LETTER N WITH TILDE */ 
		/* 0xF2 */ 0x0323, /* COMBINING DOT BELOW */ 
		/* 0xF3 */ 0x00F3, /* LATIN SMALL LETTER O WITH ACUTE */ 
		/* 0xF4 */ 0x00F4, /* LATIN SMALL LETTER O WITH CIRCUMFLEX */ 
		/* 0xF5 */ 0x01A1, /* LATIN SMALL LETTER O WITH HORN */ 
		/* 0xF6 */ 0x00F6, /* LATIN SMALL LETTER O WITH DIAERESIS */ 
		/* 0xF7 */ 0x00F7, /* DIVISION SIGN */ 
		/* 0xF8 */ 0x00F8, /* LATIN SMALL LETTER O WITH STROKE */ 
		/* 0xF9 */ 0x00F9, /* LATIN SMALL LETTER U WITH GRAVE */ 
		/* 0xFA */ 0x00FA, /* LATIN SMALL LETTER U WITH ACUTE */ 
		/* 0xFB */ 0x00FB, /* LATIN SMALL LETTER U WITH CIRCUMFLEX */ 
		/* 0xFC */ 0x00FC, /* LATIN SMALL LETTER U WITH DIAERESIS */ 
		/* 0xFD */ 0x01B0, /* LATIN SMALL LETTER U WITH HORN */ 
		/* 0xFE */ 0x20AB, /* DONG SIGN */ 
		/* 0xFF */ 0x00FF, /* LATIN SMALL LETTER Y WITH DIAERESIS  */ 
	};

	public static char[] getCodePageTable(int cpNumber) {
		char[] table = new char[256];
		for (int i = 0; i < 128; i++) {
			table[i] = (char) i;
		}

		char[] cptable;
		if (cpNumber == 437) {
			cptable = cp437;
		} else if (cpNumber == 720) {
			cptable = cp720;
		} else if (cpNumber == 850) {
			cptable = cp850;
		} else if (cpNumber == 852) {
			cptable = cp852;
		} else if (cpNumber == 862) {
			cptable = cp862;
		} else if (cpNumber == 866) {
			cptable = cp866;
		} else if (cpNumber == 874) {
			cptable = cp874;
		} else if (cpNumber == 1250) {
			cptable = cp1250;
		} else if (cpNumber == 1251) {
			cptable = cp1251;
		} else if (cpNumber == 1252) {
			cptable = cp1252;
		} else if (cpNumber == 1253) {
			cptable = cp1253;
		} else if (cpNumber == 1254) {
			cptable = cp1254;
		} else if (cpNumber == 1255) {
			cptable = cp1255;
		} else if (cpNumber == 1256) {
			cptable = cp1256;
		} else if (cpNumber == 1257) {
			cptable = cp1257;
		} else if (cpNumber == 1258) {
			cptable = cp1258;
		} else {
			System.err.println("Usupported codepage: " + cpNumber);
			cptable = cp437;
		}
		for (int i = 128; i < 256; i++) {
			table[i] = cptable[i - 128];
		}
		
		return table;
	}
}
